=====================================================================================

                                AFP2web's History


=====================================================================================
New Features and Recent History
=====================================================================================
2025-01-28 [version 4.3.0.108]
  -- AFP to PDF: Fixed incorrect overay positioning when overlay included on more than one page

2024-12-06 [version 4.3.0.107]
  -- Fixed bug in processing IOCA FS45 TIFF compressed CMYK planes for AFP to PDF transformation

2024-04-17 [version 4.3.0.106]
  -- Fixed TIFF (8bpp) container object rendered as black box issue in PDF

2024-03-29 [version 4.3.0.105]
  -- Fixed incorrect position of GOCA content when content region falls in multiple cartesian quadrants

2024-03-01 [version 4.3.0.104]
  -- Fixed incorrect position of IOCA images

2024-02-29 [version 4.3.0.103]
  -- Fixed "E091: Output buffer of IOCA/IOB object (PSG00006) is null" error while process AFP container objects having PDF data

2023-05-12 [version 4.3.0.102]
  -- Extended to ignore ColSizeN mask for color value in 'Set Extended Text Color' control sequence of Presentation Text SFI

2022-11-29 [version 4.3.0.101]
  -- Fixed minor left position difference issue with QR code image (IOCA IBM MMR image with Scale to Fit mapping)

2022-10-17 [version 4.3.0.100]
  -- Fixed incorrect presentation size for QR code image (IOCA IBM MMR image with Scale To Fit mapping) when the image width is not byte aligned

2022-09-15 [version 4.3.0.99]
  -- Fixed minor bug in evaluating scanline size for AFP included external 4 bpp TIFF image

2022-02-21 [version 4.3.0.98]
  -- When "CMYKTORGB=off", Fixed bug in determining samples per pixel (as 3) for IOCA FS 45 24 bpp RGB image

2022-01-21 [version 4.3.0.97]
  -- Extended to decode IOCA FS 11 single band image with TIFF LZW 8 bpp data

2021-12-09 [version 4.3.0.96]
  -- Fixed bug in positioning rotated GOCA texts

2021-11-17 [version 4.3.0.95]
  -- Fixed bug in evaluating GOCA box corners when corner lies in vertex of coordinate system

2021-08-31 [version 4.3.0.94]
  -- Fixed minor bug in getting stats of input files having size >2Gb in Windows OS

2021-07-13 [version 4.3.0.93]
  -- Fixed bug in handling mismatching resolutions specified in following SFIs of AFP GOCA object
     a. OBD: Object Area Descriptor
     b. GDD: Graphics Data Descriptor
     Resolution given in OBD is used by default now

2021-04-05 [version 4.3.0.92]
  -- Extended to support AFP fonts (coded font, character set and code page) with non IBM standard names
     i.e, Font resource names might not start with IBM standard characters (X or C or T respectively)

2021-04-01 [version 4.3.0.91]
  -- Fixed bug in naming PDF Type 3 fonts (made of AFP charset/codepage) when name has '#' char in it

2021-03-25 [version 4.3.0.90]
  -- Fixed minor bug in passing through predictor value when passing through TIFF:LZW input data to PDF output AS IS

2021-03-10 [version 4.3.0.89]
  -- Fixed JVM crash bug in writing AFP IOCA FS 10 IBM MMR compressed image in PDF output
  -- Extended to compress AFP IOCA FS 10 IBM MMR as CCITT4 image for PDF output

2021-02-02 [version 4.3.0.88]
  -- Extended to support input files having size >2Gb in Windows OS

2021-01-28 [version 4.3.0.87]
  -- Fixed minor bug in validating licensee with USID

2021-01-27 [version 4.3.0.86]
  -- Extended to render control characters (like tab, form feed etc) as space only when the text is applied with non custom encoded font
     during PDF to RASTER transformations or when rasterizing AFP embedded PDF containers

2021-01-19 [version 4.3.0.85]
  -- Ensured to rasterize PDF containers with IOB SFI specified resolution to avoid incorrect evaluation of presentation size

2021-01-13 [version 4.3.0.84]
  -- Fixed bug in rasterizing PDF containers when low resolution (<=200 dpi) is used for rasterized images

2021-01-05 [version 4.3.0.83]
  -- Improved handling of the background transparency for rasterized PDF object container

2020-12-28 [version 4.3.0.82]
  -- Fixed minor bug in processing Include Object (IOB) SFI for resource name specified through
     "Replace First GID" of Fully Qualified Name triplet
  -- Extended to handle the background transparency for rasterized PDF object container with transparency

2020-12-10 [version 4.3.0.81]
  -- Extended to handle default font encoding (1200) for data font referred in Map Data Resource
     (when Encoding Scheme Triplet is missing)
  -- Extended to handle resource name hierarchy given in Begin Resource (BR) and Begin Container Object (BOC) SFIs
     (either as SFI name or as Replace GID using Fully Qualified Name Triplet)
  -- Extended to substitute/embed fonts for data font given in Object Container
  -- Extended to support Object container with multipage PDF
  -- Extended to parse and support page id given in Object Offset Triplet of Include Object (IOB) SFI
     for multipage PDF object container
  -- Forced to embed equivalent external font (Type 1 or TrueType) for OpenType data font
  -- Fixed minor bug in evaluating char width from substituted TTF fonts

2020-11-05 [version 4.3.0.80]
  -- Fixed bug in processing NEWDOC return value from afp2web() of scripting facility for LPD input

2020-07-06 [version 4.3.0.79]
  -- Extended to support the Object Container having non-OCA Object Type "PDF with Transparency (Encoded Object-type OID: 06072B120004010131)"
     for AFP to PDF transformation

2020-05-18 [version 4.3.0.78]
  -- Extended C SDK with afp2web_getUniqueSystemId API to get unique system id
  -- Extended to write SF added above page objects for PDF to TIFF NCO transformation

2020-03-02 [version 4.3.0.77]
  -- Fixed minor bug in processing IOCA FS 11 image with TIFF LZW 8 bpp data for non best match algorithm output

2019-10-14 [version 4.3.0.76]
  -- Extended to support IOCA FS 11 image with TIFF LZW 8 bpp data
  -- Extended to parse/render GOCA defined texts

2019-04-17 [version 4.3.0.75]
  -- Fixed bug in processing Type 1 data embedded in AFP outline character set for AFP to TIFF transformation
  -- Fixed bug in building encoding table for Type 1 data based on AFP outline character set and AFP code page

2019-02-25 [version 4.3.0.74]
  -- Extended to write HRI (Human Readable Interface) text of AFP Code128 type barcode for AFP to PDF transformation
  -- Fixed minor bug in positioning AFP DataMatrix type barcode when symbol resolution is specified in "BDD Barcode Data Descriptor" SFI

2019-01-12 [version 4.3.0.73]
  -- Extended to support AFP barcodes defined in AFP overlays for AFP to PDF transformations

2018-12-07 [version 4.3.0.72]
  -- Fixed minor bug in AFP IM RASTER image processing when cell size/fill rectangle size were specified as 0xFFFF in IM Image Cell Position (ICP) SFI

2018-11-26 [version 4.3.0.71]
  -- Fixed bug in merging quantization table and image data for TIFF embedded single strip JPEG (compression=0x07)

2018-11-20 [version 4.3.0.70]
  -- Fixed minor bug in processing IM RASTER image (single cell and data without byte alignment)
  -- Fixed minor bug in processing GOCA box order, when GOCA window span across quadrants and any one corner lies in X axis

2018-06-14 [version 4.3.0.69]
  -- Extended to process GOCA order whose definition is split across consecutive Graphics Data (GAD) SFIs

2018-06-05 [version 4.3.0.68]
  -- Fixed minor bug in validating optional Fully Qualified Name Triplet (of type 0xBE) when parsing Map Data Resource SFI repeating group

2018-06-04 [version 4.3.0.67]
  -- Optimized AFP IM Raster image cell data replication by making PDF pattern (AFP to PDF transformation)
  -- Optimized AFP IM Raster images rendering by reusing identical (cell having same data, size, resolution) cells (AFP to PDF transformation)
  -- Fixed minor bug in processing GOCA points when GPS window spans across more than one quadrant

2018-05-03 [version 4.3.0.66]
  -- Extended with "[PDFOutput]->PDFVersion" INI option to specify PDF output version

2018-04-30 [version 4.3.0.65]
  -- Extended Scripting Facility with 'a2w::Page::isMediumMapInvoked' API to know medium map invoked before the page or not

2018-02-07 [version 4.3.0.64]
  -- Fixed minor bug in detecting structured fields for MMD input with RDW lines

2018-01-31 [version 4.3.0.63]
  -- Fixed minor bug in rotating image objects when rotation is specified on 'Include Page Segment/Include Page Overlay' SFIs

2018-01-05 [version 4.3.0.62]
  -- Fixed minor bug in processing GOCA positions specified in 4th quadrant

2017-11-27 [version 4.3.0.61]
  -- Fixed bug in decoding IOCA IBM MMR images when compressed data pattern match G4 EOL (End Of Line) pattern

2017-08-24 [version 4.3.0.60]
  -- Fixed minor bug in fetching matched entry from [AFPFont] section of font mapping for PDF to AFP transformation
     which make texts to be rasterized.
  -- Extended AFP code page resource parsing to support double byte code points
  -- Extended to process UTF-16BE/UNICODE encoded mapped font name and PTOCA texts (using iconv)

2017-07-28 [version 4.3.0.59]
  -- Fixed minor bug in evaluating success status for last eyecatcher (split using custom rules in scripting facility) document in protocol fil

2017-05-16 [version 4.3.0.58]
  -- Fixed minor bug (page created before printing line instead of after printing line) in
     processing X'89' (skip to channel 1 after printing line) Machine Code carriage control
     of MMD input.

2017-04-12 [version 4.3.0.57]
  -- Fixed minor bug in using configured input format (MMD) due to auto detected input format (AFP)

2017-03-29 [version 4.3.0.56]
  -- Fixed minor bug in applying invoked medium maps on page for MMD to AFP transformation
  -- Fixed minor bug in processing "no space before/after printing line" carriage controls for MMD input

2017-03-15 [version 4.3.0.55]
  -- Extended to apply medium map on page using Scripting Facility 'a2w::Page::setMediumMapName' API for LPD to AFP transformation
  -- Extended to process external formdef (specified using -fd command line option) for LPD input
  -- Fixed minor bug in processing [AFPFONT] section's "<Typefacename>#Height=..." entry for LPD to AFP transformation

2017-01-31 [version 4.3.0.54]
  -- Fixed major bug in decoding flate encoded PDF page content streams using Zlib

2017-01-04 [version 4.3.0.53]
  -- Fixed minor bug in processing byte aligned (RIDIC) IOCA FS 10 G4 image data for AFP to PDF transformation

2016-11-01 [version 4.3.0.52]
  -- Fixed bug in TIFF:OJPEG input processing that crash transformation

2016-10-24 [version 4.3.0.51]
  -- Extended Scripting Facility "a2w::Page::addAnnotation" API to open URL in new window/tab

2016-09-12 [version 4.3.0.50]
  -- Extended to scale images when saving through Scripting Facility a2w::Image::saveAs API

2016-07-28 [version 4.3.0.49]
  -- Fixed inverted AFP IOCA uncompressed image bug for AFP to PDF transformation

2016-07-18 [version 4.3.0.48]
  -- Extended "AFPOutputFlags" option following flags to control writing of Begin/End Document and Begin/End Named Page Group SFIs on AFP output.
     WriteBDTEDT=On (default)|Off, To write or not to write the Begin Document (BDT) and End Document (EDT) SFIs
     WriteBNGENG=On (default)|Off, To write or not to write the Begin Named Page Group (BNG) and End Named Page Group (ENG) SFIs
  -- Extended to handle unknown function set IOCA with single band CMYK image data

2016-07-05 [version 4.3.0.47]
  -- Fixed incorrect presentation size bug for IOB included IOCA images, where IOB overwrites presentation size of IOCA image

2016-06-10 [version 4.3.0.46]
  -- Fixed bug in evaluating IOCA image presentation size when IOCA is included on page using
     IOB and IOB specifies presentation size to override image specified presentation size.

2016-05-24 [version 4.3.0.45]
  -- Fixed inverted (AFP IM RASTER single cell) image bug. Reason, Image (best compressed as FLATE for PDF output)
     is inverted with out checking it's PHOTOMETRIC.

2016-04-11 [version 4.3.0.44]
  -- Fixed minor in Flate compressed color image data for PNG to PDF transformation

2016-04-06 [version 4.3.0.43]
  -- Fixed minor bug in license validation for input format, when auto detected and configured input formats differ

2016-04-01 [version 4.3.0.42]
  -- Fixed inverted PDF output bug for PNG input, where PNG (best compressed as FLATE) gets inverted since
     PHOTOMETRIC of image is not checked

2016-02-26 [version 4.3.0.41]
  -- Fixed minor bug in applying best compression for AFP GOCA Raster image during AFP to PDF transformation

2016-01-13 [version 4.3.0.40]
  -- Fixed bug in processing AFP outline font resource's FNN (Font Name Map) given GCGID to Postscript name mapping
  -- Fixed RGB planes swapped bug while saving image PNG from Scripting Facility using a2w::Image::saveAs API

2015-11-18 [version 4.3.0.39]
  -- Fixed bug in compressing attachments on PDF when attachment size is greater than 16k

2015-11-02 [version 4.3.0.38]
  -- Extended to add attachments on PDF output
  -- Extended Scripting Facility a2w::Document module with new API "addAttachment( Filename, Description )"
     to add attachments dynamically
  -- Extended with new INI section [PDFOutput] to configure PDF output specific parameters
     a. Added "Attachments" option under this section to specify attachments list
     b. Added "PageMode" option under this section to specify page mode on PDF viewer.

2015-10-14 [version 4.3.0.37]
  -- Extended to support RGB (24 bpp) planes in AFP IOCA FS-45 image (even though AFP IOCA specification allows
     only CMYK (32 bpp) planes in AFP IOCA FS-45)

2015-10-06 [version 4.3.0.36]
  -- Extended to search and load external object container files CASE-INSENSITIVE (both name and extension) on *NIX OS

2015-08-26 [version 4.3.0.35]
  -- Fixed minor bug in handling position of GOCA image when defined in page segment and included on page
     through overlay

2015-08-20 [version 4.3.0.34]
  -- Fixed bug in processing TIFF input with JPEG compressed image, which leads to 'Out of memory' error
     when opening output PDF in Acrobat

2015-07-23 [version 4.3.0.33]
  -- Fixed memory leak bug that leads AFP2web Server Asynchronous transformation to fail and
     this bug occurs while resizing images using private key for AFP to PDF transformation 

2015-07-06 [version 4.3.0.32]
  -- Extended to down sample input images (when mapping option does not trim) based on a private key
     to get optimized output size for AFP to PDF transformation.

2015-06-26 [version 4.3.0.31]
  -- Extended to handle corrupted Flate compressed image data (in Zlib based decoder)
     for PDF to TIFF transformation

2015-06-23 [version 4.3.0.30]
  -- Fixed the issue that caused "G3 1D compressed IOCA images is not supported" error for 
     IOCA FS-45 one bit/pixel input images for AFP2PDF conversion
  -- Fixed GOCA object disposition problem due to incorrect handling of include positions 
     specified in GOCA's Object Area Position and Page's Include Page Segment
  -- Ensured to trim GOCA line and box content while writing, when those objects overflow beyond 
     page box, instead of trimming based on GOCA box at parsing itself.
  -- Fixed an error that caused "Not a JPEG buffer" PDF library error, for simple IM Raster Images 
     for AFP to PDF conversion with doc_cold option
  -- Fixed JVM crash bug when input AFP contains more than one index with NULL value

2015-06-16 [version 4.3.0.29]
  -- Improved Zlib component version to 1.2.8, to resolve "-5, Insufficient Data Buffer" error
     (It occurred due to 'Ulong' data type conflict between AFP2web's Zlib component and system Zlib)
  -- Fixed JVM crash bug when following Java SDK API is used and input AFP contains index with NULL value
     public int afp2web(Properties propConfigPar, String[] sarrFileNameListPar, A2WDocumentWriter a2wDocumentWriterPar)
  -- Improved AFP IM Raster image CELL processing with best compression for AFP to PDF transformation

2015-06-05 [version 4.3.0.28]
  -- Extended with "ScaleToSize" option (PDF input ONLY) to scale output pages when input page size is not matching configured size and condition.
  -- Extended with "BWSampler" option to use different bit demote techniques (dither or adaptive threshold or limit based threshold) for 1 bpp RASTER output
  -- Extended with "TransformationProfile" option to define sub set of configuration options grouped for specific transformation needs.

2015-04-24 [version 4.3.0.27]
  -- Extended Linux USID generation to use available network interfaces info, when standard network interface (eth0) is missing

2015-04-21 [version 4.3.0.26]
  -- Fixed PDF parser bug which decode Flate compressed page content stream chunk incorrect and thus leading to illegal text operations
  -- Extended to process X'4B' (Measurement Units) triplet of "IOB - Include Object" SFI as mandatory on conditions
     described by MODCA specification (on "IOB - Include Object" SFI)
  -- Fixed minor bug in positioning IOCA (included using IOB) due to unhandled 'Reference Coordinate System' value (1)

2015-03-06 [version 4.3.0.25]
  -- Extended to abort transformation when input PDF has dynamic XFAForm instead of reporting as unsupported object

2015-02-19 [version 4.3.0.24]
  -- Extended to report dynamic XFAForm as unsupported object (using return code 2) for PDF input

2014-12-17 [version 4.3.0.23]
  -- Fixed light color (WHITE) background missing (due to transparency) bug for AFP IOCA FS 45 CMYK planes on CMYK PDF output
  -- Fixed AFP GOCA line too thin (due to improper scaling of line width) bug for AFP to PDF transformation
  -- Extended to support AFP indexes (Tag Logical Elements) that occur within AFP document state (i.e, within Begin Document - BDT/End Document - EDT)
  -- Fixed minor bug in positioning AFP IM RASTER image with single cell when position is NOT specified in Image Output Control (IOC) SFI

2014-12-12 [version 4.3.0.22]
  -- Upgraded PDF parser, (non coded output) renderer module version to latest (v3.04)
  -- Extended to support XFAForms of PDF input

2014-11-28 [version 4.3.0.21]
  -- *** Added HTML output support ***
  -- Fixed Java SDK crashing bug when 'StartingPage' config option set with value '>1' for PDF input to non coded output transformations
  -- Fixed characters overlapping and descender part missing bug when text applied AFP font metrics have kerning and invalid descender depth

2014-09-12 [version 4.3.0.20]
  -- Extended to ignore values given for invalid rotations in "FontOrientation" structured field of AFP charset resource.

2014-08-06 [version 4.3.0.19]
  -- Fixed invalid PDF output image dictionary bug for transparent GIF input transformation

2014-07-16 [version 4.3.0.18]
  -- Fixed a bug in calculating line length and width when page rotation is specified for PDF input files.
  -- Fixed a bug that overrides font styles (bold, italic) while getting AFP font resources from mapping.def for PDF input fonts.

2014-07-10 [version 4.3.0.17]
  -- Fixed application crash that skipped output image data creation for AFP GOCA and IOCA input images for Raster output.
  -- Fixed a bug that caused invalid presentation size for IOCA Images for AFP2AFP conversion

2014-07-04 [version 4.3.0.16]
  -- Extended to use default resolution when input image resolution is zero or not given

2014-04-14 [version 4.3.0.15]
  -- Fixed minor bug of missing AFP IM Raster (single celled) image on AFP to TIFF (GD) transformation, when cell data is not byte aligned

2014-04-11 [version 4.3.0.14]
  -- Extended to support 8 bits/pixel JPEG compression for TIFF:JPEG to PDF conversion

2014-04-04 [version 4.3.0.13]
  -- Extended to support CID keyed, custom CMAP encoded input fonts for PDF to AFP conversion
  -- Fixed minor bug in AFP output page rotation handling for PDF to AFP transformation with DOC_COLD/DOC_INDEX file creation modes

2014-01-31 [version 4.3.0.12]
  -- Fixed a bug in evaluating rotation angle of input PDF texts occurring in different quadrants

2014-01-30 [version 4.3.0.11]
  -- Fixed bug in decoding PDF CCITTFax filter image data decorated by another
     filter (where error occurred on processing image data as if not decorated)

2014-01-24 [version 4.3.0.10]
  -- Extended AFP to AFP transformation to support IOCA FS 45 (input) image to IOCA FS 11 (output)
     image conversion
  -- Fixed memory leaks with rasterized page image processing for AFP to AFP (nco) transformation
  -- Fixed minor bug in logging text used font info which cause core dump on Solaris

2014-01-23 [version 4.3.0.9]
  -- Enhanced performance when scaling output (using "OutputScale" configuration) for non-coded PDF2TIFF
     transformation on Linux 64 bit versions

2014-01-13 [version 4.3.0.8]
  -- Extended a2w::Vector with new SF API "getColor" in order evaluate unique colors
     count in SF customization
  -- Extended AFP2web Scripting Facility with following modules to analyze image and
     vector contents of page
     a. a2w::Image
     b. a2w::Vector
  -- Extended with following config option to turn on/off writing 0x5A Structured Field
     introducer for AFP output (Refer afp2web.ini for more details)
     * AFPOutputFlags, INI option name
     * -aof, Command line option
  -- Fixed a minor bug in PDF page content block rasterized as AFP IOCA FS 10, where
     "Image Data Descriptor - IDD" SFI contained image width mismatch against
     "Image Picture Data - IPD" SFI due to byte alignment of data.

2013-11-22 [version 4.3.0.7]
  -- Fixed a bug in processing "Repeat String" AFP PTOCA control sequence that lead to
     trailing null characters (which in turn translated as spaces on output) after
     repeating the string.

2013-09-26 [version 4.3.0.6]
  -- Fixed a bug in type3 font character metrics calculation for PDF2AFP conversion
  -- Fixed a bug in generating code page resource for type3 input fonts for PDF2AFP conversion 

2013-09-18 [version 4.3.0.5]
  -- Extended to render Scripting Facility added texts, lines and images before/after page content.
  -- Fixed a bug in TIFF:LZW greyscale output due to the conversion of both color table and data
  -- Fixed a bug in TIFF:JPEG color output due to missing JPEG tables
  -- Extended to handle "Invoke Medium Map" structured field occurring in AFP spool without "Begin/End Document"

2013-09-12 [version 4.3.0.4]
  -- Extended to use DEFAULT font height when GCSGID,FGID based height evaluation leads to non standard values
  
2013-08-07 [version 4.3.0.3]
  -- Extended to apply Best Match compression algorithm for Transparency Image Masks occuring within AFP IOCA FS-45 images.
  -- Fixed bug in the $a2wLine->remove() Scripting Facility API for PDF output.
  
2013-07-16 [version 4.3.0.2]
  -- Fixed "AFP fonts change over on texts does not work" bug for LPD/MMD to RASTER transformations

2013-07-01 [version 4.3.0.1]
  -- Extended to return special successful code (2) when PDF input spool contains MaskedImages, CID Fonts with custom CMaps

2013-06-10 [version 4.3.0.0]
  -- Extended to handle old format of Page Definition files for MMD input.
  -- Fixed font not switching issue for MMD to PDF conversion 
  -- Fixed unknown error occurred for MMD to TIFF conversion
  -- Fixed a bug in float point value truncation that caused lines characters missing for LPD to TIFF conversion
  -- Fixed bug in handling "BitOrder" value given through "Image Encoding" field of AFP IOCA image
  -- Fixed bug in evaluating symmetry of image to resize image properly which in turn avoid slow performance
  -- Extended to skip (optionally) image width evaluation from image data, to improve performance
  -- Fixed bug in extracting rasterized text block for no color, BW outputs for PDF to AFP transformations.
     PDF special colorspaces DeviceN, Separation and ICCBased color values were interpreted using alternative
     colorspace to extract rasterized text content properly.
  -- Fixed bug in evaluating font height for AFP FGID font mapping as monospaced type is considered as default.
     AFP2web now identifies proportional or mono spaced fonts using FGID as per AFP speciication
  -- Fixed an issue that caused segmentation fault for PDF2AFP(Color, Grayscale and B/W output) transformations
     when resources are not found.
  -- Migrated to "Maas Holding GmbH" from "OXSEED Aktiengesellschaft"

2013-04-26 [version 4.2.0.24]
  -- Forced non coded output option for PDF to TIFF transformation.
  -- Fixed a bug with Non Coded Output processing that caused JPEG output creation instead 
     of TIFF when Page output is turned on.

2013-04-18 [version 4.2.0.23]
  -- Extended to use Maas Image library dithering as default, for PDF2AFP B/W Non Coded Output.
  
2013-04-16 [version 4.2.0.22]
  -- Fixed a bug in filling color table entries for PDF to AFP:BW Non Coded output
  
2013-04-03 [version 4.2.0.21]
  -- Fixed bug in evaluating font height for AFP outline fonts due to invalid assertion 
     against current graphics state during AFP to PDF/A transformation

2013-03-15 [version 4.2.0.20]
  -- Fixed a bug in evaluating AFP GOCA orders count for PDF horizontal, vertical lines applied with dash pattern

2013-02-21 [version 4.2.0.19]
  -- Fixed improper rectangle output bug on PDF to AFP transformation due to data type truncation 
     of size when creating IPS line out of it.
  -- Fixed DIVIDE BY ZERO error when evaluating boundary of PDF line having identical value for 
     starting and ending points.
  
2013-02-13 [version 4.2.0.18]
  -- Fixed a bug that lead to improper tiff output instead of exception for PDF2TIFF transformation when disk is full.

2012-12-13 [version 4.2.0.17]
  -- Fixed a bug in processing pattern color space applied PDF 1 bpp images for AFP output

2012-12-12 [version 4.2.0.16]
  -- Fixed a bug while downsampling AFP IOCA FS-11 JPEG color data as 8 BPP flate data for grayscale PDF output
 
2012-12-06 [version 4.2.0.15]
 -- Fixed memory overrun bug when extracting rasterized texts from page for PDF to AFP:BW transformation

2012-11-27 [version 4.2.0.14]
 -- Fixed a bug in evaluating raster block size for "Code-39" font applied texts in PDF2AFP conversion
   
2012-11-21 [version 4.2.0.13]
  -- Fixed black pages on output bug for PDF to TIFF transformation

2012-11-15 [version 4.2.0.12]
  -- Fixed a black output page bug in processing IOCA FS 11 (24 bpp JPEG) image, where JPEG data is
     grayscaled twice (while decoding and encoding) when 'Color=off'.

2012-11-09 [version 4.2.0.11]
  -- Extended to handle Type3 fonts of PDF input, having vector and raster glyphs
  
2012-10-10 [version 4.2.0.10]
  -- Extended to stop transformation when PDF input contains dynamic acroforms

2012-10-09 [version 4.2.0.9]
  -- Extended to rasterize PDF input texts applied with custom/built-in encodings when "ToUnicode" table is not given on font dictionary
  -- Extended to create AFP PTOCA lines for PDF input filled vertical thin rectangles for PDF2AFP conversion
  
2012-09-28 [version 4.2.0.8]
  -- Fixed minor bug in evaluating position of images added through Scripting Facility with rotation >0

2012-09-25 [version 4.2.0.7]
  -- Fixed missing image bug due to improper color table processing for PDF to AFP transformation
  -- Extended with "AutoRotateImage" feature (for PDF to AFP transformations only)
  -- Fixed image tiling bug when rasterizing pattern filled input PDF vector contents
  -- Optimized rasterizing shading filled input PDF vector contents
  -- Optimized processing vector contents of PDF input

2012-08-08 [version 4.2.0.6]
  -- Fixed a minor bug in PDF to RASTER transformation on *NIX OS, where grayscale (8 bpp) data color processing made all pixel as black
  -- Fixed a minor bug in identifying PDF image mask type for PDF to AFP transformation
  
2012-07-27 [version 4.2.0.5]
  -- Extended to support transparent images for PDF and Raster outputs   
  
2012-07-20 [version 4.2.0.4]
  -- Fixed minor bug in inverted PDF output problem on TIFF to PDF transformation, when TIFF is LZW compressed and Photometric interpretation tag value is "Black is Zero"
  -- Extended to process PTOCA unchained control sequence introducer (0x2BD3) that occur split in consecutive 'Presentation Text - PTX' SFIs
  -- Enhanced PDF2AFP performance by optimizing floating point operations
  
2012-07-05 [version 4.2.0.3]
  -- Extended to generate AFP (Non Coded Info) outputs. Can be generated by setting "CodedOutput=Off" along with AFP output options
  -- Extended with "OutputScale" configuration option to control output size with dynamically and better constraints
  -- Fixed minor bug in handling input format config option, where in given value and actual file format are not matching

2012-06-22 [version 4.2.0.2]
  -- Fixed minor bug in 'MaxVectorObject' configuration, where the value ">0" has no impact on processing vector contents on PDF to AFP transformation

2012-04-05 [version 4.2.0.1]
  -- Fixed AFP IOCA FS-45 JPEG compressed image not presented on PDF output bug for B/W case, where image is best compressed as GRAY SCALE JPEG
  -- Fixed bug in transforming GOCA cartesian co-ordinate points to AFP points, which leads to improper position of GOCA content on output (for AFP2PDF)  

2012-03-21 [version 4.2.0.0]
  -- Extended AFP2web license management with volume based transformation control

2012-03-13 [version 4.1.0.6]
  -- Fixed text disposition bug occur when AFP PTOCA "Set Text Orientation" control sequence given 
     after "Absolute Move Baseline" and/or "Absolute Move Inline" control sequences for AFP2AFP conversion
  -- Extended 'OutputSize or -os:<size>' configuration with STANDARD paper size values A0 to A10,
     B0 to B10 and C0 to C10. For example, OutputSize=A3.
  -- Extended to handle width mismatch for AFP IOCA FS-45 (JPEG compressed) images, when width given
     in 'Image Data Descriptor' SFI and actual image data were different

2012-02-24 [version 4.1.0.5]
  -- Optimize memory usage during Non Coded Output for PDF to RASTER transformation

2012-02-16 [version 4.1.0.4]
  -- Fixed bug in evaluating count value on 'LNC-Line Descriptor Count' structured field of DATA MAP resource for MMD inputs
  -- Fixed bug in reading lines after an Structured Field for MMD input
  -- Extended to handle Medium Map actions and Data Map Actions given on 'Conditional Processing Control' structured field of Page Definition

2011-12-21 [version 4.1.0.3]
  -- Fixed minor bug in detecting PDF font 'ToUnicode' table existence
  -- Extended to rasterize PDF texts applied with Identity-H/V encoding and not having 'ToUnicode' table

2011-12-08 [version 4.1.0.2]
  -- Fixed improper trimming for AFP IOCA FS-45 image when image's Object Area and Image Presentation space resolutions 
     are different and applied with 'Position and Trim' mapping option
     
2011-12-01 [version 4.1.0.1]
  -- Fixed first page repeated on all pages of output bug with PDF to PDF (non coded) transformation
  -- Fixed minor bug in processing position parameters of 'a2w::Page::addImage' Scripting Facility API for RASTER to RASTER transformation

2011-11-22 [version 4.1.0.0]
  -- Enhanced following PDF/A-1b compliance issues
     a. Confirmed compliance for 'Creator' element value of 'Dublin Core' schema RDF description
     b. Extended with AFP2web extension schema to pack document indexes
  -- Fixed following minor bugs in 64 bit SDK versions
     a. Empty document buffer in document writer callback for single page output formats (like JPEG, PNG etc)
     b. Missing document index info in document writer callback for PDF and RASTER input formats
  -- Upgraded PDF parser, (non coded output) renderer module version to latest (v3.03)
  -- Fixed minor bug in rendering soft mask of vector graphics for PDF input

2011-10-24 [version 4.0.0.15]
  -- Fixed bug in finding raster block position that start out of page boundary (which result in displacement of raster block on output)
  -- Extended text rotation evaluation when texts are presented through PDF form

2011-09-30 [version 4.0.0.14]
  -- Fixed following issues for Aix 64 bit version
     a. Core dump error with PDF/A output generation
     b. Type 1 font loading error for MMD to PDF transformation
     c. Escaping special chars error on PDF output generation, which leads to empty text on output
     d. AFP outline font mapping error for MMD to AFP transformation

2011-09-16 [version 4.0.0.13]
  -- Extended to support PDF images with Color-Key Masks
  -- Extended rasterized (SOCA colored) texts blocks grouping for PDF2AFP conversion
  -- Fixed a bug in evaluating foreground color applied with color space for 1 bpp PDF images
  -- Extended Logging level "INWARN" to include "version information", "Command Line Options",  "Parsing Page" and "End of Spool/Process" exception 
  -- Added new configuration parameter "SKipImageSize" to skip images with size less than or equal to specified width & height for AFP output
  
2011-09-13 [version 4.0.0.12]
  -- Fixed minor bug in processing INI path and filename passed in as property to C SDK APIs
  -- Extended AFP "Map Coded Font" processing to evaluate font height from font width when fonts
     are mapped using GCSGID and FGID

2011-08-29 [version 4.0.0.11]
  -- Extend with presentation text fidelity option (CHAR or TEXT level) to control text presentation for AFP output
  -- Enhanced grouping rasterized custom encoded text objects for PDF input
  -- Enforced AFP IS2 (& PT1) compliance for AFP output, when AFPComplianceLevel option is set to 'modcais2'
     For example
     a. Grouping pages (with Named Page Group) for 1 to n conversions is skipped
     b. Presentationt text control sequences are strictly adhered to PT1 subset value ranges
  -- Extended PDF parser to get configuration file (Option 'PDFParserConf') from afp2web.ini file
  -- Extended to return special successful code (2) when input spool contains some unsupported content (applies to PDF input only)

2011-08-17 [version 4.0.0.10]
  -- Fixed memory leaks occurred while resizing images for AFP output with MO:DCA IS2 compliance

2011-07-27 [version 4.0.0.9]
  -- Initial Aix 64 bit Java SDK Release

2011-07-13 [version 4.0.0.8]
  -- Fixed first vector content not rasterized bug (when 'MaxVectorObjects=0' on ini) for PDF2AFP conversion

2011-07-06 [version 4.0.0.7]
  -- Fixed memory overrun bug while processing AFP PTOCA 'Repeat String' control sequence
  -- Fixed problem with using same font for evaluation text and watermark (added through Scripting Facility)
     text in AFP2PDF/A conversion for Evaluation license

2011-06-13 [version 4.0.0.6]
  -- Initial 64 bit Java SDK release on Windows
  -- AFP2web by default now use GD based engine for RASTER outputs on 64-bit Windows OS
  -- Fixed a minor bug in accessing before page indexes (i.e, Indexes that occur before Begin Page mark)
  
2011-05-09 [version 4.0.0.5]
  -- Ignored AFP GOCA text objects that are not supported in order to avoid unknown error.
  -- Extended A2W to process AFP GOCA ARC objects with rotated Major/Minor Axis.
  
2011-04-28 [version 4.0.0.4]
  -- Initial Windows release on 64-bit architecture with all supported conversions 
  
2011-04-12 [version 4.0.0.3]
  -- Extended code point translation for 'Symbol' and 'Zapfdingbats' (PDF Base Fonts) for PDF2PDF conversion
  
2011-04-08 [version 4.0.0.2]
  -- Fixed a minor bug in mapping PDF base fonts whose name end with '-Roman' (e.g, Times-Roman) for PDF2PDF conversion
  -- Extended AFP2web license key verification to tolerate uncertain DST value from 'localtime()' WIN32 API

2011-03-31 [version 4.0.0.1]
  -- Extended to PDF image dictionary processing to handle "/Name" attribute is missing case
  -- Fixed a minor bug in evaluating image presentation size for PDF2PDF conversion

2011-03-17 [version 4.0]
  -- Extended Scripting Facility with following features
     a. New module "a2w::Comment" to add comments on PDF output
     b. "a2w::Document" module extended to add comment, fetch PDF document properties and PDF metadata stream
  -- Extended to support PTOCA (MO:DCA IS1/2) AFP input, that map fonts using FGID, GCSGID and CPGID
  -- Extended to support GOCA having image for AFP2AFP conversion
  -- Extended to support Container Objects for Raster outputs
  -- Extended raster output generation to render 1 bpp images transparent (i.e. by ignoring background pixels)
  -- For PDF2AFP conversion, images with 1 pixel presentation width or height that occur consecutively are
     grouped together for better image handling and output size
  -- Fixed a bug in Black & White coded output for ANY2AFP conversion
  -- Fixed Unknown error that occur while processing image object with empty data
  -- Fixed Unknown error that occur due to incorrect maximum character box width and height
     in AFP Raster Font with outline metrics
  -- Fixed logging related bugs
  -- Fixed memory leak bugs for different conversions
  -- Upgraded dependent modules upto date except PDF parser module
  -- Fixed unknown error/core dump bug in AFP IOCA RL4 data decoding due to memory over run
  -- Extended to handle PDF document property having UNICODE TEXT STRINGS (on PDF2AFP conversion)
  -- Upgraded dependent library Zlib from V1.2.3 to V1.2.5
  -- Improved PTOCA suppression block processing to increment cursor position by text width even if the text
     is suppressed (for AFP to PDF and PDF/A conversions)
  -- Extended to handle AFP FGID font for AFP to Raster conversion
  -- Improved AFP resource group generation (for AFP output) to pack all resources used by page directly
     or indirectly (i.e. page included resource included resources are also packed properly)
  -- Fixed dangling pointer problem while processing AFP Raster image (AFP2PDF conversion)
  -- Fixed color component swapped bug processing CMYK color value (which occured only on *NIX OS)
  -- Fixed junk text on output bug in processing PTOCA controls that span over 2 consecutive "Prsentation Text (PTX)" SFIs
  -- Fixed text missing bug in processing PTOCA "Free Transparent Data"
  -- Fixed improper statistics bug in standard version processing
  -- Fixed a memory leak that occurred while validating the corrupted external AFP resources 
     that lead to JVM crash for Java SDK (AFP2PDF conversion)
  -- Fixed a first page image being repeated for all following pages problem on multi page TIFF to PDF conversion
  -- Fixed the AFP IM Raster & GOCA Raster image dis-positioning problem, when image is presented on page through
     included Page Segment (where Page Segment contain more than one image object)
  -- Extended AFP2web version string with build system architecture constants as given below
     "32-bit" for 32 bit machines
     "64-bit" for 64 bit machines
     AFP2web version will look like as given below
     For 32 bit machine: Running AFP2web v4.0 [Built for Windows 2003/2008 32-bit on Jun 28 2010 at 14:40:15]
     For 64 bit machine: Running AFP2web v4.0 [Built for Windows 2003/2008 64-bit on Jun 28 2010 at 14:40:15]
  -- Fixed bug in processing AFP GOCA Image fore color (given in RGB Colorspace) for AFP to Raster (GD based) outputs
  -- Fixed bug in applying AFP medium map on page when medium map invoked using "Fully Qualified Name" Triplet
     (FQNType=0x8D) on following Structured Fields
     a. Begin Page (BPG)
     b. Begin Named Page Group (BNG)
     c. Index Element (IEL)
  -- Consolidated AFP2web through intensive unit tests
  -- Extended AFP2web license validation on Aix to be LPAR specific
  -- Fixed a minor bug occurred in XPDF while processing secured PDF input
  -- Fixed a dangling pointer problem on PDF parser when caching embedded fonts on
     system temp path (on *NIX OS)
  -- Extended RASTER output (generation on *NIX OS) to support AFP outline fonts
  -- Extended RASTER output (generation on *NIX OS) to support following AFP GOCA content
     - Line (with dash pattern)
     - Box (both regular and rounded corners)
     - Arcs (both partial and full)
     - Fillets
     - Markers
  -- Fixed a bug in TIFF library call back error handling that lead to JVM crash for tif2tif(b/w) conversion.
  -- Fixed segmentation fault occured during MMD to PNG/GIF/PCX conversions on BIG ENDIAN machines (Solaris/Aix)
  -- Fixed bug in positioning scripting facility added image for AFP2PDF conversion, when input page content
     is rotated other than zero
  -- Extended to identify whether IOCA IBM MMR RIDIC data is padded or not and ensured to process both cases
  -- Extended to support TIFF input having tiles
  -- Extended to tolerate recoverable errors occur during PDF parsing, by treating those errors as warnings
  -- Initial 64 bit release on Linux
  -- Remodeled License validation process
  -- Fixed bug in rendering IOCA FS-45 (Tiled) image with "Position And Trim" mapping option for PDF output
  -- Fixed bug in rendering IOCA FS-45(Tiled) Image with "Center and Trim" mapping option treated as "Scale To Fill" for PDF Output
  -- Fixed a minor bug in specifying values for following document properties when generating secured PDFs (using "PDFSecurity" config option)
     a. Author
     b. Producer
  -- Extended PDF parser to use OXSEED image library to decode CCITTFax streams when decompression fails with it's own decoder.
  -- Extended to render HRI (Human Readable Interpretation) text for Code39 barcode type
  -- Extended to process resources packed with or without BRS/ERS envelope in AFP Resource Group
  -- Extended PDF parser to handle AES buffer overrun when decrypting AES V2 secured PDF
  -- Fixed missing null terminator char bug in fetching localized Java String value on Java SDK C wrapper 
  -- Fixed a null charset bug while getting localized string data in Java SDK
  -- Extended AFP IOCA G3/G4 encoded data processing to use image height based on decoded data,
     where in case of decode error, the last successfully converted line number will be used
     as image height
  -- Extended following APIs of "a2w::Font" Scripting Facility module to return proper font information for PDF input
     1. getName
     2. getTypefaceName
  -- Extended AFP Page inline IM Raster image processing by removing intermediate data buffers to optimize memory usage
  -- Fixed minor bug in processing image color when resizing (to match 'Scale To Fit' mapping option) for AFP MOD:CA IS2 output
  -- Fixed the bugs occurred specific to 64-bit architecture
  -- Initial Linux release on 64-bit architecture with all supported conversions
  -- Skipped processing unsupported AFP container objects
  -- Fixed a bug in processing IOCA images when CMYKTORGB=off, which used to raise
     "Output buffer of IOCA/IOB object (IO100001) is null" error
  -- Extended IOCA FS45 Image processing with best compression for output size reduction when CMYK2RGB=off
  -- Fixed a bug with substituting AFP coded fonts for PDF input
  -- Fixed a bug in evaluating whether TIFF compressed data is padded or not, for PDF CCITT images

2010-04-01 [version 3.3]
  -- Migrated to "OXSEED Aktiengesellschaft" from "Maas High Tech Software GmbH"
  -- Extended PDF2AFP process with better rasterization of not handled content to avoid overlapping
  -- Extended font configuration (mapping.def  with new "Input Font Alias" section) to support alias names 
     for input fonts. ( NOTE: This currently supported only for PDF2AFP conversion process )
  -- Extended text encoding process for better data mining on Scripting Facility
  -- Added column description, ".notdef" character to all cp files in afpcp dir.
  -- Added support for Coded and NonCoded outputs for PDF input format
  -- Extended MMD input processing with Siemens Machine Code Carriage Control support
  -- Fixed a bug in accessing translated text from Text objects using Scripting Facility
  -- Fixed a bug in processing AFP IOCA images when X and Y resolution (given Image Data Descriptor) are
     different for AFP2PDF Conversion
  -- Extended PDF input processing with page rotation (i.e. When PDF Page dictionary has Rotation parameter) 
     support
  -- Added page flushing feature for PDF output to minimize memory usage
  -- Fixed a minor bug in processing rotated images along with flip for PDF2AFP conversion
  -- Fixed unknown error problem that occur while deleting internal font objects made of external resources for AFP2PDF conversion
  -- Fixed unknown error problem that occured while binding text used font resources for LPD2PDF conversion
  -- Fixed bug in switching fonts for text writing when page included overlay content is written after page content,
     where the font local id is same in page and overlay context for AFP2PDF conversion
  -- Fixed a minor bug in evaluating non-overlapping raster blocks when blocks to be merged have different colored content
  -- Fixed a minor bug in fetching rasterized image block when height is 1 pixel (which occur due to position round off while type casting)
  -- Fixed a minor bug in handling MaxVectorObjectCount that forced object to be rasterized even though it is not necessary
  -- Extended to configure minimum and maximum shading value for AFP color table values (and is used now only for GRAY color on PDF2AFP conversion)
  -- Fixed a bug when mapping rasterized PDF page (color curve or slanting vector content) image pixels to B/W (1 bpp) image pixels,
     due to lossy rasterization for PDF2AFP conversion
  -- Extended color handling while rasterizing Non AFP color PDF input content, i.e. Rasterized as JPEG (IOCA FS 11)
     applicable only for PDF2AFP (MODCA P compliance) conversion
  -- *** Added PNG output support ***
  -- Fixed a minor bug in positioning rasterized vector content when position is rounded off for PDF2AFP conversion
  -- Fixed a minor bug in fetching bounding box for non straight vector contents
  -- *** Standardized AFP2web C SDK ***
  -- Extended font substitution for Identity-H, Custom and Built-In encoding cases
  -- Extended to process rotated text content on PDF2AFP conversion
  -- Fixed a minor bug while finding character width when character is not defined in substituted font  
  -- Extended to add NOP in Page for PDF2AFP conversion
  -- Fixed a minor bug in specifying output format when using C SDK's "afp2web_mem" API
  -- Fixed segmentation fault that occured due to memory over run while substituting font for Identity-H, Custom and Built-In
     Encoding cases
  -- Fixed unknown error problem that occured while accessing Tag element for PDF2AFP conversion
  -- Fixed a minor bug in evaluating the co-ordinates of the line object to be rendered as vector content for PDF2AFP conversion
  -- Extended to configure Standard Version performance using licensee
  -- Fixed a minor bug in evaluating Bounding box for Rotated text
  -- Fixed a minor bug for content duplication for PDF2AFP conversion
  -- Fixed overlapping problem when word spacing is specified for Identity Encoded texts
  -- Fixed NZW filled vector content missing problem for PDF2AFP conversion
  -- Extended image processing with best compression for output size reduction
  -- Fixed minor memory leak problem on following situations
      a. While allocating page list for MMD input
      b. While processing Line object data for MMD input
  -- Fixed minor bug while splitting document for MMD input spool.
  -- Extended AFP2web client to start preview by default
  -- Fixed a minor bug while generating single page Raster outputs (like JPEG, PNG) for "DOC_COLD" file creation mode
  -- Fixed unknown error problem that occured while saving page for PNG output and "DOC_COLD" file creation mode
  -- Fixed a bug while fetching the graphic objects (line, text) color through Scripting Facility
  -- Fixed improper page fetching bug for raster output when "-pp" option is used
  -- Fixed a minor bug for command line option "-if" when ini filename is specified without path
  -- Fixed a bug while rasterizing Vector Content having white color for PDF2AFP conversion
  -- Extended page rotations "portrait" and "landscape" for all output formats
  -- Extended statistic file generation to add date along with time on "Started at" and "Ended at" fields
  -- Fixed minor bug on processing "ToUnicode" CMAP table's "bfrange" and "bfchar" values for PDF input
  -- Extended to support 32 bpp (e.g. TIFF:LZW with CMYK) image included on page by AFP external container object or by Scripting Facility
  -- Fixed a minor bug in vector content positioning for PDF2AFP conversion (where AFPComplianceLevel is "modcais2")
  -- Extended AFP2web to use GD (instead of Win32 GDI) based rendering engine for PNG output on Windows
  -- Fixed minor bug in color swapping (RGB to BGR) for 24 bpp PNG output  
  -- Fixed empty word spacing problem in PDF2AFP conversion due to improper handling of PDF word space reset value
  -- Fixed black shading problem for AFP2PDF conversion when input AFP contain IOCA FS 45 (8 bit, CMYK planes) image
  -- Fixed a bug in filling "DECODEPARMS->k" value of PDF image object for G3 compressed image data (that result from
     Best Match Compression analysis of AFP IOCA 1 bpp image)
  -- Optimized memory allocation while decoding IOCA FS 45 image for "Position And Trim" map option
  -- Fixed a minor bug in configuring output size for RASTER outputs using "OutptSize" config attribute/"-os" command line option
  -- Extended Scripting Facility with "a2w::Comment" module to add comments on PDF at document level
  -- Fixed "Out of Memory" error occured while evaluating boundary of curve paths for PDF2ANY conversions    
  -- Fixed missing text bug in PDF2ANY conversion for "Non Coded Output" due to improper font type flag handling for external font files
  -- Fixed bug in handling "ScaleToFit" mapping option for IOCA FS-45 tiled images for PDF output
  -- Fixed a minor in positionning AFP GOCA image occuring in AFP page segments

2009-06-03 [version 3.2]
  -- Modified usage text for "macid" parameter
  -- All AFP objects are written in the same order as they appear on AFP input stream
  -- Added support for IOCA FS45 images with multiple tiles for AFP2PDF process
  -- Applied best compression algorithm to AFP IM Raster images for AFP2PDF process
  -- Added support to get macids from IPV6 Network adapters
  -- Enhanced logging
  -- Scripting procedure file name (passed using "-sp" or "ScriptProcedure") is prefixed
     with ini path in case the Scripting procedure file path is relative not absolute
  -- Modified PDF document Properties as given below
     a. "Creator" ini attribute will used as "Author" PDF document property
     b. "Creator" PDF document property is obsolete and used for internal activity
  -- Extended PDF/A output to match PDF/A specification, corrigendum 1
     (ISO 19005-1:2005, TECHNICAL CORRIGENDUM 1, Published on 2007-04-01, Corrected version on 2005-12-01)
  -- Added support for processing PDF Bookmarks
  -- Extended A2W licence key backward compatibility for V3.1 and above
  -- Fixed a bug with AFP2web return value when E084 exception is thrown.
  -- Modified PDF Doc limit evaluation with better factorization  
  -- Fixed minor bug with -pp option
  -- Extended insufficient memory handling for string operations
  -- Extended XPDF library to support PDF outline items with destination position as "null"
  -- Fixed minor bug with SF APIs a2w::Page::setWidth() and a2w::PagePage::setHeight() to resize output page
  -- Added new SF APIs
     "a2w::Kernel::getVersion" and
     "a2w::Kernel::getVersionAll"
     to get version info and subcomponent detail
  -- Added "getExitStatus()" API to "a2w::kernel" scripting facility module
  -- Fixed minor bug while prepending ini path to relative path value (given to any path attribute)
  -- Fixed a bug with AFP Raster image handling when cell's fill rectangle size (either width or height or both) is zero
  -- Fixed a minor bug in "getNextText" API of a2w::Page Scripting Facility module
  -- Extended PDF output with better transparency
  -- Fixed a bug with IOCA image color processing for B/W output
  -- Extended Java SDK with a new INI constant property "JDK_CHARSETNAME", to specify encoding/codepage for all property values
  -- Extended A2W JDK to use system default characterset for the conversion of java strings used to give input file names to C strings
  -- Extended to set "Recording Id" parameter of AFP IOCA images properly based on image data byte alignment
  -- Added Private Key to force byte alignment of image data for AFP output.
  -- Extended MMD ASA carriage control with custom values to apply page definition properly
  -- Extended Transparency customization (for PDF output only) with light foreground color blending
  -- Extended A2W to support AFP IOCA image with transparency mask for AFP2PDF process
  -- Fixed minor bug in packing font resources on resource group for AFP output
  -- Fixed unknown error bug while setting output filename without extension using
     Scripting Facility Document module's "setOutputFilename" for AFP2AFP conversion
  -- Fixed missing text bug while rasterizing for AFP2TIFF conversion   
  -- Extended A2W to support any type of CID font for PDF2AFP process
  -- Fixed problem with inline images process for PDF2AFP process
  -- Ignored warning "No current point in closepath" from libXPDF occured for PDF2AFP process
     and continued processing
  -- Optimized IOCA FS-45 image data processing by means of output size and performance
  -- Customized GOCA border line drawing even for the INVISIBLE line type
  -- Fixed minor bug with rectangle disposition due to position type conversion for PDF2AFP conversion
  -- Fixed minor bug with white texts while rasterizing for PDF2AFP conversion
  -- Added Conditional Control Processing support for MMD Input format
  -- Fixed a bug with creating output files in subdirectories for Document Count(-dc) command line option
  -- Fixed a bug in handling single strip TIFF inputs with OJPEG compression
  -- Fixed bug with rasterizing custom encoded characters for PDF2AFP conversion
  -- Extended with "-q2" option to supress printing product copyright details on batch process
  -- Fixed minor bug with AFP2web exit status (to be 0) when AFP2web stops with Warning or Info type exceptions
  -- Fixed bug in writing space character for AFP2ANY output
     NOTE: Space character is not written instead position is incremented
  -- Fixed a bug with rasterizing umlaute characters for PDF2AFP process
  -- Fixed a bug with USID Generation on Windows that occured when daylight saving time is off. 
  -- Extended resource group generation with below given configuration for AFP output
     a. Don't generate resource group
     b. Generate only one resource group (even generated output is more than one)
     c. Generate one resource group for each AFP output
     NOTE: "ResourceGroup" ini attribute and "-rgp" command line option are added
           to allow above configuration
  -- Extended AFP inline resources processing, so that resource group generated for
     AFP output will now have them too.
  -- Fixed minor bug with AFP2web exit status
  -- Fixed a bug with Scripting Facility added image's type detection
  -- Fixed a bug with Scripting Facility added image's disposition
  -- Extended to rasterize Text, Vector contents whose color is other than AFP SOCA colors
     when AFP compliance level is "MODCA-IS2" for PDF2AFP process
  -- Fixed (texts are not written on AFP output) bug that occurs when NO ENCODING is given
     PDF font dictionary for PDF2AFP process
  -- Extended support to process image within AFP GOCA objects
  -- Extended with LibTIFF V3.8.2 integration to avoid some memory leaks
  -- Fixed minor memory leak problem while processing AFP Raster image with cells
  -- Fixed minor memory leak problem while cleaning up AFP2web in exception cases
  -- Extended to handle anonymous inter control sequence data as (Free) Text on AFP Presentation Text (PTX) Structured Field
  -- Enhanced AFP MODCA IS2 compliance for PDF2AFP process
     a. Rasterized PDF paths having Non-SOCA color
     b. Used "SetLineWidth" GOCA Order instead of "SetFractionalLineWidth" order
     c. Ensured PTOCA control sequence values are in valid range
     d. Ensured Object Area Position SFI values are in valid range
     e. Added Map Page Overlay in AEG for overlays used in page
  -- Added support for following missing TIFF compressions while  writing PDF, AFP and Raster outputs formats
     CCITT modified Huffman RLE 
     #1 w/ word alignment
     IT8 Linework RLE
     IT8 CT w/padding
     IT8 Linework RLE
     IT8 Monochrome picture
     IT8 Binary line art
     Pixar companded 10bit LZW
     Pixar companded 11bit ZIP
     Deflate compression
     Deflate compression
     ThunderScan RLE
     Kodak DCS encoding
     ISO JBIG
     SGI Log Luminance RLE
     SGI Log 24-bit packed
     Leadtools JPEG2000
  -- Fixed a minor bug in writting clipped objects for PDF2AFP process
  -- Extended PDF2TIFF conversion to support PDFs having Type1/TrueType 
     embedded fonts with custom encoding.
  -- Extended to handle AFP character set resources having same Font Global IDs (FGID)     
  -- Extended PDF2TIFF conversion to support PDFs having Type3 Fonts
  -- Fixed minor bug in asserting INI path for JAVA SDK APIs
  -- Extended exception handling at process initialization level for JAVA SDK APIs
  -- Fixed a bug in writing rotated images for Raster output
  -- Fixed a bug in positioning rasterizing text for Raster output
  -- Fixed minor bug in reading optional fields from TIFF input
  -- Extended to handle different X & Y resolution on TIFF2ANY conversion
  -- Extended to support page rotation for Raster Output
  -- Fixed a bug in setting color for clip area objects for PDF2AFP process
  -- Input images are resized to image presentation size to meet AFP IS2 compliance for AFP output
  -- Color of PDF input text objects, horizonal lines, vertical lines and rectangles are mapped 
     to nearest AFP SOCA color to meet AFP IS2 compliance for AFP output
  -- Extended E104 exeption to display path list where ini file is searched for
  -- Extended to redirect console messages to a file instead of STANDARD ERROR
  -- Fixed bug in byte alignment padding of AFP IOCA with uncompressed image data
  -- Fixed minor bug in TIFF input with "Old JPEG" compression
  -- Fixed minor bug in handling Built-In font encoding for PDF2AFP conversion
  -- Extended to support IOCA images given in AFP Resource groups
  -- Extended to fetch proper width from AFP IOCA Image when image data descriptor given width 
     and actual image width are not same
  -- Fixed a bug with handling buffers returned from environment fucntions,
     that caused segmentation fault on AIX 5.1.
  -- Fixed a bug with creating AFP character set and code page resources from Type3 font on PDF2AFP conversion
  -- Extended Java SDK with "CHECKOUT" functionality APIs
  -- Extended Scripting Facility to add user data to a2w::Document instance
     and to access such added user data on Java SDK's document handler call
     back implementation
  -- Fixed minor bug in passing INI path property for Java SDK APIs, Now
     "IniPath" is considered as a valid property for backward compatibility
  -- Fixed a minor bug with font resolution manipulation for Type 3 PDF fonts
  -- Modified naming convention of AFP characterset/codePage resources
     generated from Type3 PDF fonts as given below
     Character set Name : C1<PDF Object id as 5 digit>A
     Codepage Name      : T1<PDF Object id as 5 digit>A  
  -- Fixed unknown error occured for PDF2AFP process when ResourceGroup option is set to 1.
  -- Extended to support PDF input images with top left corner outside page boundary
  -- Modified naming convention of AFP characterset/codePage resources
     generated from Type3 PDF fonts as given below
     Character set Name : C0<PDF Object id as 5 digit>A
     Codepage Name      : T0<PDF Object id as 5 digit>A
  -- Fixed a minor bug in handling filled rectangles for PDF2AFP process
  -- For AFP MODCA IS2 compliant output, "White" color of PTOCA objects is mapped to 
     "Reset Medium Color (X'FF08')"
  -- Modified naming convention of AFP codePage resources generated from Type3 PDF fonts as given below
     Codepage Name : T1<PDF Object id as 5 digit>A
  -- Fixed minor bug in filling transparency image mask width/height info on AFP2PDF conversion,
     when AFP IOCA image has PositionAndTrim/ReplicateAndTrim mapping option
  -- Extended Java SDK API
     int afp2web( java.util.Properties propConfigPar,
                  java.lang.String[] sDocumentIdsPar,
          A2WDocumentReader a2wDocReaderPar,
          java.lang.String sOutputFilenamePar )
     with Scripting Facility support
  -- Fixed minor bug in manipulating resolution given in GOCA windows specification
  -- Modified AFP Codepage generation with CPI repeating groups sorted based on Graphic Character Id
     for PDF2AFP process as default
  -- Fixed below given minor bug in AFP character set generation from type3 PDF font.
     a. Identifying space character
     b. Specifying space character increment on FNO( Font Orientation ) SFI. 
     c. Specifying maximum character box width, height and use flag on FNC( Font Control ) SFI.
  -- Extended to have different license verification process for Batch/SDK and Client products.
  -- Extended "DocumentReader" callback implementation to pass through document indexes as list.
  -- Fixed minor bug in index process (i.e. passing in input indexes to output) for AFP2AFP conversion.
  -- Fixed a bug in writing AFP outline font resources with same typeface name for PDF output.
  -- Optimized page rotation for (GD based) raster outputs
  -- Fixed minor bug in barcode object positioning when it is rotated other than zero degree 
  -- Fixed minor bug in AFP Raster image writing problem on AFP2AFP conversion
  -- Extended to handle (Adobe Photoshop created) 32 bit CMYK JPEG input (for JPEG to PDF conversion)
  -- Fixed a bug in adding input AFP used FormDef/MediumMap resource on output AFP resource group for AFP2AFP conversion
  -- Fixed a bug in adding input AFP page included overlay resource on output AFP resource group for AFP2AFP conversion
  -- Fixed a bug in passing through AFP IPS (Include Page Segment) SFI from input AFP to output AFP with it's equivalent action
     (i.e adding page segment objects to page) on AFP2AFP conversion when AFPComplianceLevel is MODCAIS2
  -- Fixed a bug in identifying celled AFP IM Raster Image and Generating equivalent AFP IM Raster Image for AFP2AFP conversion
  -- Modified Maximum Structured Field data length limit to 8192 bytes from 32759 for MO:DCA P Compliance AFP Output
  -- Fixed a minor bug in Type3 font generation from AFP font when space character increment is zero for AFP2PDF conversion
  -- Extended to add Map Page Overlay (MPO) SFI on Active Environment Group (AEG) of page respective to each
     Include Page Overlay (IPO) on page for AFP2AFP (MO:DCA P compliance output) conversion
  -- Extended Java SDK with A2WDocumentWriter document writing callback interface instead of A2WDocumentHandler
  -- Extended to support AFP FS-45 IOCA images with 1 Bits/Pixel
  -- Extended to fetch proper width from AFP IOCA (MMR compressed) Image when image data descriptor given width 
     and actual image width are not same
  -- Fixed minor bug in processing INIPATH and INIFILENAME ini attributes as well as a minor 
     bug in iterating document id list after retrieving the last document in the following Java API:      
     int afp2web( java.util.Properties propConfigPar, java.lang.String[] sDocumentIdsPar,
                  A2WDocumentReader a2wDocReaderPar, java.lang.String sOutputFilenamePar )
  -- Fixed bug in finalizing (PERL) Script Engine which leads to Java Virtual Machine crash when any Java SDK API is invoked 
     with DOC_COLD file creation mode more than once in same JVM context on *NIX operating systems
  -- Extended to handle mismatching character metrics on AFP Raster fonts for AFP to TIFF (GD based) and PDF conversions
     (When character width is not equal to sum of A, B and C space values of character glyph)
  -- Externded to support input PDF images with softmask
  -- Fixed minor bug in identifying image type when image added from Scripting Facility
  -- Extended Java SDK index translation with JDK_CHARSETNAME encoding
  -- Duplicated user given property list passed to any Java SDK API to avoid user info
     being modified by AFP2web
  -- Fixed minor bug in evaluating font height from AFP character set when font height
     is set zero on AFP character set
  -- Fixed minor bug in processsing End Document (EDT) SFI when SFI name is less than
     expected 8 characters length  
  -- Fixed minor bug in process AFP GOCA Box command when start and end point
     are not top-left and bottom-right respectively
  -- *** Added PNG input support ***
  -- Fixed bug in PDF security for BIG_ENDIAN machines (like Solaris, Aix)
  -- Enhanced text rasterization to ignore Glyph background for Raster Output
  -- Fixed a bug in skipping PDF objects that occur outside of clip area
  -- Extended to handle invalid character metrics (A, B and C space values) given in AFP Raster Fonts by processing given below
     a. Character increment (or width) is used to position the glyph
     b. B space is evaluated from glyph width always and Font Index (FNI) given B space is just ignored
     c. A space is evaluated in below given priority
        1. "Uniform A space" flag is turned "on" in Font Orientation (FNO) SFI,
           Font Orientation (FNO) SFI specified A space value is used
        2. Font Index (FNI) specified A space value is negative and less than Font Orientation (FNO) specified A space value,
           Font Orientation (FNO) SFI specified A space value is used
        3. Use Font Index (FNI) specified A Space value
  -- Fixed a bug (missing image on output) for JPEG to ANY conversion on Solaris, that occur due to file size evaluation failure
  -- Fixed memory leak on rasterizing rotated glyphs that caused unknown error for Raster output
  -- Extended IOCA(JPEG) image processing with new "Colorspace" ini attribute to customize JPEG color space for PDF output
  -- Fixed unknown error bug that occured while reading "Predictor" tag from TIFF:UNCOMPRESSED input
  -- Extended to support Uncompressed TIFF with 48 Bits/Pixel (i.e 16 Bits/Color component) RGB colorspace data for PDF and PDFA output  
  -- Extended to handle negative positions for AFP data objects (like image) as per MO:DCA specification to fix bug in image misposition
  -- Extended to support CID fonts with CIDToGIDMap encoding table for PDF2AFP conversion
  -- Extended to support IOCA FS 45 CMYK Image with 4 Bits/Pixel for PDF output
  -- Fixed a minor bug when more than one AFP fonts are mapped to Same External font.
  -- Fixed a minor bug in handling AFP IOCA image with IBM MMR compression, RIDIC=0x01 and byte-aligned data.

2008-06-18 [version 3.1]
  -- Implemented new licence key process using Unique System Id
  -- Implemented A2W Features Control
  -- Implemented "Character Set C" for AFP CODE128 barcode 
  -- Enhanced TIFF input support with compressions
  -- Fixed minor bug with unpadded AFP IOCA images handling for AFP output
  -- Fixed minor bug with AFP Raster font handling when shape resolution is 600 dpi
  -- Added Raster Input Support for Big-Endian machines(AIX,Solaris)
  -- Fixed a bug with JPEG to TIFF conversion for UNIX TIFF output
  -- Fixed a bug with licence key verification
  -- Modified licence key verification process flow
  -- Fixed minor bug in processing before page AFP indexes for Scripting Facility flow
  -- Fixed a bug with PDF string width evaluation when AFP variable space character increment 
     is given for non-space text context
  -- Fixed a bug in mapping.def under PDFFONT section while processing more than one font alias
  -- Extended with minor set of MOD:CA Interchange Set 2 compliance
     a. Extended to write optional fields on "Font Descriptor Specification - FDS" triplet
     b. Ensured following SFIs to have max length of 8200
        => Image Picture Data (IPD) SFI
        => Presentation Text (PTX) SFI
        => Barcode Data (BAD) SFI
        => Graphics Data (GAD) SFI
     c. Extended IOCA FS-11 with "External Algorithm Specification Parameter" for JPEG compression
     d. Ensured to have "Scale to Fit" (0x20) value on Map Image Option (MIP) SFI's Map Option Triplet
     e. Ensured "End Document" (EDT) SFI not to have any triplets
  -- Fixed minors bugs while writing details on following SFIs
     a. Ensured "Object Area Position Id" value is >0 in Object Area Position (OBP) SFI
     b. Ensured "X content orientation" value is 0x0000 in Object Area Position (OBP) SFI
     c. Ensured "Y content orientation" value is 0x2D00 in Object Area Position (OBP) SFI
     d. Ensured "Descriptor Position Triplet" value is >0 in Object Area Descriptor (OBD) SFI
  -- Fixed minor bug in processing before page AFP indexes for Scripting Facility flow
  -- Fixed a bug with PDF string width evaluation when AFP variable space character increment 
     is given for non-space text context
  -- Fixed minor bug in processing before page AFP indexes for Scripting Facility flow
  -- Customized to avoid displaying Info messages in case of I000 & I001 Exceptions
  -- Fixed a memory leak occured while writing image objects for PDF2TIFF
  -- Extended to support PDF curves for AFP output
  -- Fixed a bug in handling PDF word space and Intercharacter increment for AFP output
  -- Extended to evaluate font height based on text matrix for PDF input
  -- Extended to handle PDF image rotations like 0,90,180,270 degrees
  -- Extended with "PrintableLineWidth" configuration attribute to control output
     line width (only for PDF2AFp process)
  -- Fixed minor bug in handling AFP raster image's cell data length
  -- Fixed Font Rasterization problems for PDF2AFP conversion
  -- Fixed text and image misplacement bugs
  -- Modified logging of PDF input parsing.
  -- Supported "Identity" encoding for font rasterizaton of PDF2AFP conversion.
  -- Handled font rasterization for fonts specified within Form Xobjects for PDF2AFP conversion
  -- Supported "Identity" encoding with unicode table for font rasterizaton of PDF2AFP conversion.
  -- Fixed a bug with adding resources for AFP output.
  -- Extended to use width array given PDF input font descriptor to
     position/render text on AFP output
  -- Extended to handle image vertical flipping on PDF2AFP conversion
  -- Forced to rasterize Identity-H/V encoded text always on PDF2AFP conversion
  -- Fixed minor bug in positioning of clipping objects
  -- Fixed minor bug in missing text for substituted fonts on AFP2PDF conversion
  -- Fixed text overlapping occured while using identity-H encoding for PDF2AFP conversion
  -- Fixed minor bug with ICCBased color space table for PDF2AFP conversion
  -- Fixed a bug with manipulation of inter character space value for PDF2AFP conversion
  -- Integrated Lib GD 2.0.35
  -- Handled 1 bpp, non AFP SOCA color images, for AFP output
  -- Fixed a bug with line width problems
  -- Extended to handle image horizontal flipping on PDF2AFP conversion
  -- Extended TIFF Decoder to handle missing RowsPerStrip tag value in TIFF header
  -- Extended support for PDF custom encoded text rasterization
  -- Extended to customize font glyph raster resolution
  -- Fixed minor bug in rotated image disposition for PDF2AFP conversion
  -- Set proper flag bits for "Font Design" & "Font Use" flags of FDS triplet based on font details
  -- Extended support for PDF NON-ZERO WINDING filled path rasterization
  -- Fixed a bug with Even-Odd fill type for PDF2AFP conversion
  -- Fixed a bug with forcing rasterization with default font for PDF2AFP conversion
  -- Extended to configure minimum AFP GOCA line width (using ini attribute "GOCALineWidth") in pixels
  -- Extended to choose TTF font interpreter at runtime for better rasterization
  -- Fixed bug in rasterizing custom encoded text applied with truetype fonts having CMAPs for PDF2AFP process
  -- Excluded loading AFP codepage resource (which caused E058 exception) for PDF2AFP process
  -- Rasterized PDF vector content based on ini attribute "MaxVectorObject"
  -- Document info AFP NOP SFIs are added within Document (after BDT SFI)
  -- Corrected AFP GOCA line width handling
  -- "GOCALineWidth" ini attribute value should be in 100 dpi
  -- LibXPDF error (invalid bfrange) is fixed
  -- Missing EDT SFI bug in generated AFP output is fixed
  -- Fixed "Error while rendering path" problem on PDF2AFP conversion
  -- Modified Unique System ID handling for Windows to exclude admin rights
  -- Fixed overlapping issues while rasterizing PDF vector contents
  -- Enhanced logging with more information
  -- Added a output format type "BW" for AFP output format to write any input image as FS-10 IOCA image.
  -- Fixed a bug with Unique System Id generation which caused unknown exception on Unix based operating systems
  -- Removed runtime dependency of "libiconv" on *nix OS
  -- Added clipping support for PDF2AFP process
  -- Fixed a bug with writing image color for AFP output
  -- Extended AFP2web to get MACId from user to generate Unique System Id(USID) on Windows
  -- Used WinAPIs to get Windows Directory, whose creation time is used to generate USID on Windows
  -- Fixed minor bug in applying AFP Medium Map specified offset for rotated AFP page content
  -- AFP Page is resized automatically to contain AFP medium overlay when overlay size falls beyond actual page boundary
  -- Added Private Key to to disable clipping option
  -- Added support to map PDF Fonts to AFP Raster fonts
  -- Fixed a bug in manipulating page size when Medium Map Resource is not given.
  -- Extended to support old syntax of [AFPFont] section of mapping.def
  -- Modified MACId as optional command line argument to generate USID on Windows
  -- Fixed a bug with page and medium content positioning when medium size is greater than page size
  -- Modified MACId command line argument to accept any delimiter to separate parts of MACId
  -- Extended to consider MACId of "cable disconnected network adapters" also, while verifying license
  -- Fixed unknown error due to insufficient memory on AFP2PDF process
  -- Modified PDF Doc limit evaluation to avoid abnormal memory pre-allocation
  -- Modified PDF Doc limit evaluation for "DOC_COLD" and "DOC_INDEX" file creation modes
  -- Modified usage text for "macid" parameter
  -- Modified external font file search for font rasterization using font family name for PDF2AFP process  
  -- Fixed a bug with clipping that occurs when output resolution and font resolution are different for PDF2AFP process
  -- Fixed LibXPDF error (Illegal entry in bfrange block in ToUnicode CMap) for PDF2AFP process
  -- Fixed a minor bug with "macid" retrieval for Windows OS.
  
2007-08-03 [version 3.0]
  --  Released AFP2web V3.0 AFP to PDF for Windows
  --  Extended scripting facility.
  --  Added font rasterization for PDF output.
  --  Added TrueType font referencing/embedding support for PDF output.
  --  Added PDF security 40/128 bits.
  --  Image handling optimized for PDF output.   
  --  Added grayscale support for Black & White PDF output.
  --  Extended GOCA support.
  --  Added AFP color support(IOCA FS 45, Container Objects, GOCA).
  --  Added support to customize output file name using pattern.
  --  Added "AFPColorTable" section in ini to customize color values.
  --  Used IBM Space character GCGID for Space Character code point instead of GCIGID given in CodePageIndex SFI.
      If IBM Space character GCGID not found in character set, then GCIGID given in CodePageIndex SFI is used.
  --  Fixed position problem occured for Image/Overlay/pagesegment objects that are added from SF
  --  Fixed bug with disposition of images within overlays that are added from SF.
  --  Fixed rotation problem occured for images that are added from SF
  --  Added Outline Font Embedding support for PDF output.
  --  Added support to provide custom encoding for PDF output.
  --  Fixed a bug in reading line width from AFP input file
  --  Fixed a bug in license key decryption
  --  Fixed a bug in checking text object's value for NULL, while writing it using Type3 Font.
  --  Fixed a bug in positioning GOCA Line Objects
  --  Fixed a bug in handling text objects added from Scripting Faclity
  --  Extended SF to set font encoding while adding texts
  --  Fixed a bug in handling FGID fonts
  --  Fixed a bug in interpreting FGID font height value.
  --  *** Added TIFF output support (Release Candidate 1) ***
  --  Added log information for Text objects for TIFF output (Release Candidate 1) 
  --  Set AFP page width instead of DWord aligned width, as TIFF output page width for TIFF output (Release Candidate 1) 
  --  *** Added ASCII output support ***
  --  Fixed position problem occured while passing CMYK IOCA image as is to PDF
  --  Fixed a bug in handling CMYK color value
  --  Added Private Key to compress AFP IM images using Flate Encode algorithm 
      instead of default G4 algorithm for PDF output.
  --  PDF Library: Modified comment line on the second line of PDF output
      to make sure that generated PDF is treated as a binary file
  --  Added support for AFP Font Rasterization for TIFF output (Release Candidate 2) 
  --  Fixed bug in handling TIFF container objects
  --  Font logging changes partially done
  --  Fixed a bug in resource loading (on Unix OS) when more than one resource
      under same directory are likely named (e.g. S1ABC, S1ABCD etc)
  --  Fixed a bug in (top-level) bookmark navigation (PDF output)
  --  Extended C SDK with following features
      a. Added "getVersionAll" API
      b. Added "afp2web_f" filename based conversion API
      c. Extended "CheckIn" process to support any input/output format
  --  Extended Java SDK with callback to handle output document buffer and indexes
  --  Added Outline font support for TIFF output (Release Candidate 3) 
  --  Fixed a bug in setting default encoding for code pages
  --  Handled text orienation for font referencing for for TIFF output (Release Candidate 3) 
  --  Added output font weight and slant information in font logging of text objects
  --  Modified font logging to display Typeface name as given in AFP Font resource.
  --  Fixed image position problem occured for images having orientation other than zero.
  --  Renamed "PDFFontPath" ini entry to "ExtFontPath"
  --  Renamed "pdffont" directory to "extfont"
  --  Fixed a bug in handling data and color of container object that has color table information
  --  Fixed a bug in handling "End Document (EDT)" SFI, when "FileCreationMode" is set to "doc_index"
      and input AFP spool has incomplete nested page groups.
  --  Added Copyright info to TIFF output
  --  Fixed a bug in document splitting when "FileCreationMode" option is set to "doc_index"
  --  Fixed a bug in finding GCGIDs of code points for outline fonts 
  --  Fixed a bug in writing watermark text for TIFF output
  --  Added Scripting Facility support for TIFF output (Release Candidate 4) 
  --  Following Scripting Facility "Font" module interfaces are modified to receive/return
      values in points (i.e. "ScriptUnitBase" ini attribute doesn't control this interfaces)
      a. setHeight
      b. setWidth
      c. getHeight
      d. getWidth
  --  Modified AFP raster image writing by merging cells together
  --  Fixed bug with accessing index details from Document instance at "initializeDoc" of SF
      when Autosplit is turned on
  --  Extended to use INI path as base path for all relative path parameters
  --  Extended to generate grayscale PDF for B/W output
  --  Added color input support for TIFF B/W output (Release Candidate 5) 
  --  Added support for JPEG B/W output
  --  Extended AFP generation with IOCA, ImImage, IOB, IPS, IPO
  --  Fixed a bug with Medium Overlay writing
  --  Fixed a bug in setting Medium Size when it is zero.
  --  Fixed a bug with adding overlay from finalizePage of SF Module
  --  Fixed a bug with adding overlay to page, that is added from SF Module
  --  Added support for Underscore and Overstrike PTOCA control sequences for AFP output (AFP RC3)
  --  BCOCA, GOCA SFIs are passed as is for AFP output (AFP RC3)
  --  Fixed a bug with paths that are specified with server names.
  --  Fixed a bug with Raster IM Images that occured for "NOCELLS" option.
  --  Fixed a bug with Raster IM Images having no cells.
  --  Fixed a bug with PTOCA "Begin Line" control sequence
  --  Added support for TIFF color output
  --  Added support for JPEG color output
  --  Added support for Single Page TIFF output
  --  Extended Scripting Facility to support Single Page output format
  --  Fixed a bug with IOB image position for PDF output
  --  Handled AFP with IOCA JPEG grayscale images for PDF and TIFF output
  --  Handled AFP with IOCA uncompressed grayscale images for PDF and TIFF output
  --  Applied PDF bug fixes except GOCA fixes to TIFF Output
  --  Based on private key "ENC_FLATE", compress, uncompressed images with 1 bit/pixel 
      using Flate Encode algorithm instead of default G4 algorithm for PDF output.
  --  Fixed bug with improper relative move presentation control sequences
  --  Fixed bug with SFIs having improper 'Flag' byte
  --  Changed process flow to find font resources.
  --  Added support to pass AFP Spool, Resource, Document Index and Form Defs
      as java input streams for JAVA SDK
  --  *** Added PDF/A output (Level B conformance) support ***
  --  Fixed IOB disposition problem when mapping option is "Position And Trim"
  --  Handled Font Horizontal Scale Factor given for outline font for PDF output
  --  Fixed a bug with underline position for PDF Output
  --  Handled PositionAndTrim, ScaleToFit Mapping option for PDF output.
  --  Fixed bug with calling SF's "initializeDoc" and "finalizeDoc", when last page
      of spool is alone splitted as one output document using eye catcher rules
  --  Fixed a bug with clock overflow on standard version
  --  Fixed minor bug with line positioning (with width factor) for PDF output when
      presentation orientation is other than zero
  --  Fixed a bug in calling callback handler for the last output document when "MemoryOutputStream"
      is "on" and input afp document is splitted using custom Scripting Facility Module
  --  Fixed minor bug due to "rdf" element name case sensitiveness in PDF Metadata generation
  --  Extended PDF Metadata generation with document indexes using Maas schema
  --  Added support to 2D Data Matrix barcode for PDF output.
  --  Fixed a bug with relative resolution given for IOCA FS 45 CMYK images
  --  Fixed a bug with Type1 font embedding on BIGENDIAN operating systems (Solaris, AIX)
  --  Fixed a bug with Image Mapping Option "Replicate & Trim" 
  --  Fixed a bug with parsing afp font resource that has glyph information referred
      by more than one character GCGID.
  --  Fixed a bug with ICC color profile for PDF/A output
  --  Metadata information "dc:creator" is set to a proper value for PDF/A output.
  --  Fixed minor bug with filling metadata values on PDF/A generation
  --  *** Added support for PDF input ***
  --  Horizontal font size of Font Descriptor triplet set with proper value in case of outline fonts for AFP output.
  --  Fixed a bug with line width for PDF input
  --  Extended with support for following issues on PDF input
      a. Color value processing
      b. Handled filled rectangles
      c. Handled text size scaling factor specified in text matrix operator ("Tm")
      d. Applied cropping to pages
  --  Added color input support for TIFF G4/G3 output formats using dithering
  --  Fixed a bug that occured when "CodePage" path length exceeds 128 characters
  --  Removed setDocumentHandler/getDocumentHandler methods from A2WSDK.java to
      achieve synchronization of A2W Java SDK methods
  --  Renamed afp2web.jar as a2wjdk30.jar for A2W Java SDK
  --  Renamed A2W Java SDK wrapper dll(afp2webWrapper.dll) as a2wjdk30.dll.
  --  Fixed a bug with setting text from Scripting Facility
  --  Extended to handle INVERT flag of GRAY SCALE IMAGE (X OBJECT) on PDF input
  --  Extended to handle process password protected PDF input
  --  Enhanced AFP patterns (1 to 8) rendering on PDF with image as basic unit of replication
  --  Fixed a bug with font embedding for PDF output
  --  Added CODE39 barcode support for PDF output
  --  *** Added support for JPEG input ***
  --  *** Added support for BMP/PCX/GIF input ***
  --  Fixed a bug with input stream handling for LPD/PDF input formats
  --  Fixed a bug with EBCDIC translation for LPD input format
  --  Added GOCA(Lines, Ellipse, Arc, Box, Area) support for Windows TIFF output
  --  Fixed a bug with multi-strip TIFF input files for TIFF2PDF conversion
  --  Fixed a bug with following A2W JDK API for PDFA output.
      int afp2web( Properties propParamsPar,
                   ByteArrayInputStream  baisInputStreamPar,
                   ByteArrayOutputStream baosOutputStreamPar ) 
  --  *** Added support for Mixed Mode Data input ***
  --  Added support for TIFF CMYK(32 Bits/Pixel) input images
  --  Fixed minor bugs with applying page definition on MMD spool
  --  Fixed even numbered document id on output filename bug with "-page" file creation mode
  --  Added GOCA Patterns support for TIFF output
  --  *** Added support for TIFF/JPEG output on UNIX like OS ***
  --  Extended to rasterize AFP fonts for TIFF/JPEG output on UNIX like OS
  --  Fixed minor bug to ensure AFP GOCA objects writing in the same order as they occur.
  --  Removed PDF blend mode
  --  Customized to write PDF Page used XObjects as inline IOCA objects on AFP Page
  --  Fixed minor bug while writing AFP font resources on AFP output
  --  Fixed minor bug while validating raster line reading for IOCA (CMYK) images
  --  Extended AFP font rasterization handling for PDF output when descender metrics were improper
  --  Fixed a bug that caused an unknown error when an invalid output format is specified
      while using JAVA SDK APIs.  
  --  Fixed a minor bug with AFP outline coded font rasterization for Windows TIFF output.
  --  Modified EBCDIC encoding generation for Windows TIFF output while rasterizing AFP outline font.
  --  Optimized large size AFP IOCA object parsing.
  --  Fixed a bug with log file generation occured while using JAVA SDK stream APIs for LPD and Raster input formats.
  --  Fixed a bug to ensure AFP objects within overlay are written in the same order as they occur.
  --  Fixed a minor bug in parsing AFP inline object containers occurring within Page/Overlay

2005-08-02 [version 2.1 r34]
  --  Added Eyecatcher text "Warning!" to unsupported barcode types
  --  Fixed unknown error that occured for afp samples having unsupported barcode types.

2005-07-14 [version 2.1 r33]
  -- Fixed bug with loading font resources using name patterns having wild cards on
     unix based platforms

2005-05-25 [version 2.1 r32]
  -- Fixed bug with text object disposition when absolutely moved in one direction
     (either I or B) alone and orientation is other than zero

2005-05-23 [version 2.1 r31]
  -- Fixed bug with processing more than one file that contain inline document index
  -- Fixed bug with raster image positioning that occur direct in page

2005-05-19 [version 2.1 r30]
  -- Fixed page content disposition problem due to missing medium offset scaling process

2005-05-12 [version 2.1 r29]
  -- Fixed problem with GOCA lines that has starting point as (0,0).

2005-05-10 [version 2.1 r28]
  -- Fixed bug with graphic & presentation objects disposition
  -- Extended support to write rotated images on TIFF (Windows only) output

2005-04-19 [version 2.1 r27]
  -- Fixed bug in GOCA Fillet processing

2005-04-01 [version 2.1 r26]
  -- Fixed bug with IMM SFI processing when "doc_index" option is specified

2005-03-22 [version 2.1 r25]
  -- Extended Scripting Facility with following features,
     a. To customize page background color
     b. To include page background form objects
     NOTE: Both features applicable for PDF output only

2005-03-10 [version 2.1 r24]
  -- Tif warnings are logged and process continued, instead of throwing exceptions.
  -- Usage of wildcard character "?" for finding FTP font resource removed. Instead used "0"/"1" as second character.
  -- Added FTP log level to log FTP access deatils

2005-03-01 [version 2.1 r23]
  -- Used character increment width for numerals instead of Figure Space Increment
  -- For B/W output, medium color is displayed as white instead of black.

2005-02-24 [version 2.1 r22]
  --  Moved toRGB() method of mhtGraphicObejct class to mhtUtils class.
  --  Handled Fill and Stroke colors properly for PDF Output
  --  Fixed GOCA fill problem

2005-02-10 [version 2.1 r21]
  --  Added support for 600dpi resolution of AFP font resources

2005-02-09 [version 2.1 r20]
  --  Bug in using default code page path in case of invalid code page path, is fixed. 

2005-02-07 [version 2.1 r19]
  --  Unknown error occured during doc_cold process fixed.
  --  Error in bookmark generation fixed.

2005-01-28 [version 2.1 r18]
  --  Added facility to get document output buffer in case of memory output stream 
      in finalizeDoc() of SF.

2005-01-19 [version 2.1 r17]
  --  Handled "Invisible" Line Type properly.
  --  Fixed error in Goca Color parsing.

2005-01-10 [version 2.1 r16]
  --  Fixed problem in filling GOCA Area Objects that has multiple paths

2004-12-28 [version 2.1 r15]
  --  Parsed IOCA foreground color specified in Image Data Descriptor SFI to fix IOCA color problem( Bug:Black color is displayed for other colors).
  --  Fixed IOCA color inversion problem in JPEG and PNG output formats

2004-12-22 [version 2.1 r14]
  -- Added support to load resources over FTP hosts

2004-12-03 [version 2.1 r13]
  -- Added support for hyperlink annotations for pdf outputf.

2004-11-26 [version 2.1 r12]
  -- Fixed bug with image truncation when IOCA image has "Position And Trim" mapping
     option

2004-11-16 [version 2.1 r11]
  -- Fixed bug with bookmark generation when AFP indexes has special characters

2004-11-04 [version 2.1 r10]
  -- Modified indexed document processing to fix problem with "-sd" option

2004-10-28 [version 2.1 r9]
  -- Extended PDF creation with user controlled (thru INI) viewer preferences

2004-10-06 [version 2.1 r8]
  -- Codepage properly handled for CODE128 Barcode Support.

2004-10-05 [version 2.1 r7]
  -- Fixed Document creation problems while using -sd and -ed option along doc_cold/doc_index. 

2004-09-30 [version 2.1 r6]
  -- Support for CODE128 Barcode type added. 

2004-09-28 [version 2.1 r5]
  -- Fixed Document creation problem( i.e,Documents are created from the Document id that is one less than StartDocument Id specified in -sd option).

2004-09-03 [version 2.1 r4]
  -- Fixed Memory problem occured due to repeated creation of DEFAULT Resources
  -- Added new log levels to log information about Global resources.
  -- Fixed unknown error that occured in LPD2web conversion when tiff object is added to the page.
  -- Fixed "Last Line Missing" problem in LPD2web conversion.

2004-07-29 [version 2.1 r3]
  -- Extended kernel to tolerate invalid triplets in SFIs

2004-07-21 [version 2.1 r2]
  -- Fixed bug with scaling text (made of one character) for PDF output

2004-06-10 [version 2.1]
  -- Fixed bug with GOCA image object positioning
  -- Fixed Solaris core dump problem while parsing GOCA within page
  ++ Version 2.1 for Windows released ++
  -- Fixed bug with treating "Object Classification" triplet as mandatory for kind of
     object type whereas it is meant mandatory only for X'92' object type
  -- Scrambled text objects randomly when accessed from Scripting Facility
     for Evaluation version
  -- Upgraded with Libtiff V3.5.7
  -- Extended "-vall" option to display Script Library version also
  -- Added "-vall" option to display versions of sub components
  -- Fixed bug with output file generation when error occurs
  -- Fixed bug with document having improperly nested page groups
  -- Optimized exception handling for Image Library calls
  -- Fixed bug with spools having junk bytes initially or in between SFIs
  -- Changed path validating process as below,
     A. Log Path      (-lp),
        Ini Path      (-ip),
        Output Path   (-op),
        Index Path    (-xp) and
        CodePage Path (-cp) are verified while initializing process

     B. Overlay Path List     (-ovp),
        PageSegment Path List (-psp),
        FormDef Path List     (-fdp),
        AFPFont Path List     (-ap),
        Resource Path         (-rp),
        Font Path             (-fp),
        MFM path              (-mp) and
        Object Container Path (-ocp) are verified at first usage

  -- Validating all path attributes (codepage, resource, font, mfm) properly
  -- Fixed unknown error that occur while adding text objects from Scripting Facility
  -- Handled Position Mapping Option for IOBs
  -- Handled snowbound unknown exceptions
  -- Subject default set to "AFP and TIFF Conversions (afp2web.com)"
  -- Added copyright and demoversion text for TIFF2PDF.
  -- Title set to "AFP2web Evaluation Version" in afp2web.ini
  -- Log file name built by adding ".log" to the input/Resouce file name 
  -- Special chars "& < > ' "" are taken care while creating index xml file
  -- Comment triplet is included in all SFIs as defined in MODCA Document
  -- CMYK colorspace handled for IOCA Images.
  -- Bug in mhtPDFLib function mpdf_finalizeAll fixed. And mhtPDFLib Version2.1r9 integrated. 
  -- Fixed the bug:If input file is in parent directory from current current directory without extenstion, exception thrown.
  -- Removed ClibPDF word. 
  -- Bug in old and new font section names fixed.
  -- Problem in page segment image misplacement fixed.
  -- Position and trim mapping option for image object handled.
  -- Problem in Goca lines fixed.
  -- Problem in mapping Character Set with more than one CodePage fixed.
  -- Low volume bugs fixed. 
  -- Protocol status saying last document as error is fixed. 
  -- Medium offset position are stored in signed variables. 
  -- Page Position specified in PGP handled.
  -- Replicate & Trim mapping option of IOCA image handled.
  -- Added Image Encoding parameter to IOCA header, it it is not present, to overcome snowbound bug.
  -- Fixed Font embeding problem.
  -- Added support to refer TrueType fonts. 
  -- Integrated Medium Map fix. 
  -- GOCA Patterns 1-10 added.

2003-12-16 [version 2.1 Beta26]
  -- GOCA ellipse drawing error fixed.

2003-12-12 [version 2.1 Beta25]
  -- GOCA Area Filling added.
  -- GOCA Position problem fixed.

2003-10-29 [version 2.1 Beta24]
  -- Added Font Flags to Specifiy Symbol/NonSymbol & Sans/Serif properties for PDF Font Referencing.

2003-10-22 [version 2.1 Beta23]
  -- Added PDF Font Referencing.

2003-10-08 [version 2.1 Beta22]
  -- Fixed bug with positioning of Included Objects.

2003-10-02 [version 2.1 Beta21]
  -- Fixed bug with misplaced Included Objects, IOCA images and color space processing.

2003-09-24 [version 2.1 Beta20]
  -- Fixed bug with Overwritten texts.

2003-09-19 [version 2.1 Beta19]
  -- Fixed bug with misplaced images.

2003-09-12 [version 2.1 Beta18]
  -- Fixed bug with shrinked text.

2003-09-06 [version 2.1 Beta17]
  -- Fixed bug with rotated text misplacement.

2003-08-06 [version 2.1 Beta16]
  -- Fixed bug with applying Figure Space Increment of Font Resource.

2003-08-01 [version 2.1 Beta15]
  -- Fixed bug with calling "initializeDoc" of Scripting Facility when last one page
     is new document

2003-07-21 [version 2.1 Beta14]
  -- Fixed bug with processing Chained Presentation Control Sequences
  -- Fixed bug with Included Object scaling

2003-07-01 [version 2.1 Beta13]
  -- Extended handling Reference Coordinate System of Object Position SFI
  -- Fixed bug with misplaced IOCA image

2003-06-25 [version 2.1 Beta12]
  -- Optimized platform specific Font/Image handle creation
  -- Extended Scipting Facility (set/get page attributes (width, height and resolution)).
  -- Extended  Include Object SFI support.
  -- Added Object Container support.
  -- Added Line Printer Data (LPD) & Mixed Mode Data (MMD) support.

2003-06-16 [version 2.1 Beta11]
  -- Extended SF to set/get page attributes like width, height and resolution.

2003-01-29 [version 2.1 Beta10]
  -- Added support to "Reference Coordinate System" flag of "Object Area Position" SFI
     (Only for IOCA images)

2003-01-20 [version 2.1 Beta9]
  -- Fixed bug with Text background color after applying Overlay.

2002-09-16 [version 2.1 Beta7]
  -- Extended  Include Object SFI support.

2002-09-02 [version 2.1 Beta6]
  -- Fixed bug with Include object positioning with external resources.

2002-08-30 [version 2.1 Beta5]
  -- Fixed bug with image promotion with Object container data.

2002-08-22 [version 2.1 Beta3]
  -- Fixed bug with N-Up partition page position info.

2002-08-02 [version 2.1 Beta2]
  -- Fixed bug with object container color.

2002-07-24 [version 2.1 Beta1]
  -- Added Object Container support.

2004-01-13 [version 2.0 r27]
  -- mhtPDFLib V2.1r5 used

2003-12-31 [version 2.0 r26]
  -- Low volume version feature added.

2003-12-23 [version 2.0 r25]
  -- Fixed bug in handling RESET_COLOR of OCA Color table

2003-11-27 [version 2.0 r24]
  -- Added Font Referencing

2003-11-04 [version 2.0 r23]
  -- Added Default Code Page in ini/Command line arg to customize the code page to be 
     used for translating index name and values

2003-10-16 [version 2.0 r22]
  -- Fixed bug with Variable Space Character Increment applying on PDF output
  
2003-10-02 [version 2.0 r21]
  -- Fixed bug with IOCA image misplacement

2003-09-29 [version 2.0 r20]
  -- Fixed bug with Image Tiling when image data is less than 8 bits
  -- Fixed bug with document index processing when page groups are indexed at page
     group level and each contains only one page

2003-08-25 [version 2.0 r19]
  -- Fixed bug with misplaced images

2003-08-14 [version 2.0 r18]
  -- Fixed bug with bookmark generation when more than one TLE occur at page group level
     
2003-06-16 [version 2.0 r17]
  -- Fixed bug with processing Index Elements without Tag Logical Elements
  -- Fixed bug with missing umlaut characters in index files

2003-04-22 [version 2.0 r16]
  -- Optimized image and font handle creation

2003-04-11 [version 2.0 r15]
  -- Fixed problem with loading external formdef resources (when used with strict option)

2003-04-02 [version 2.0 r14]
  -- Fixed bug with generated pdf filenames (PDF filename appended with username) on Aix

2003-03-12 [version 2.0 r12]
  -- Modified image writing process to write image cells individually or together.

2003-02-26 [version 2.0 r11]
  -- Extended LPD Data parsing to detect format automatically (ASA or IBM 1403)

2003-02-06 [version 2.0 r10]
  -- Extended IBM 1403 Parser with Record Data Length parsing support.

2002-12-20 [version 2.0 r9]
  -- Added internal index file writing support for Scripting Facility.
  -- Extended LPD data parsing with IBM 1403 format.

2002-12-17 [version 2.0 r8]
  -- Extended Scripting Facility to add text and index objects.
  -- Added Scripting Facility support for LPD process.
  
2002-12-03 [version 2.0 r7]
  -- Fixed bug when using SF with repeated documents (BDT/EDT SFI pairs) in AFP file.

2002-10-24 [version 2.0 r6]
  -- Modified PC font mapping process for TIFF output (under windows NT/2000).

2002-10-21 [version 2.0 r5]
  -- Fixed bug with path verification (under windows NT/2000).

2002-10-18 [version 2.0 r4]
  -- Fixed bug with watermark displaying in TIFF output (Windows only).
  -- Fixed bug with empty page while using "-sd" option.
  -- Fixed bug with protocol status when error occurs.
  -- Fixed bug with improper output document count in sub directories
     while using "-dc" option.
  -- Fixed bug with resource file loading based on extension.

2002-09-30 [version 2.0 r3]
  -- Fixed bug with cell image right alignment rendering.

2002-09-17 [version 2.0 r2]
  -- Fixed bug with invalid input file names.
  -- Fixed bug with loading resources with time stamp.
  -- Added process pages from/to page option (-pp:fp[-tp], e.g.: -pp:100-200).

2002-07-30 [version 2.0]
  -- Added Scripting Facility Option.
  -- Extended LPD process to specify background image list.
  -- Fixed bug with logging long texts.
  -- Fixed bug with sequence of resources.
  -- Fixed bug with missing BDT and EDT SFIs.
  -- Fixed Image positioning and Cell tiling problem.
  -- Fixed bug with Color Specification Triplet
  -- Fixed bug with Font Horizontal Scale Factor Triplet
  -- Fixed bug with document merge for tiff output (improper position).

2002-04-30 [version 1.2 r8]
  -- Added support for 'SYMBOL' font encoding (PDF and Windows TIFF only).

2002-03-06 [version 1.2 r7]
  -- Added customized Output Filename in the Index File info.

2001-12-12 [version 1.2 r6]
  -- Added support for external Document Index File (-xf option)
  -- Allow Font Size to be set to 0 in the mapping.def
  -- Document Index processing optimized.

2001-11-26 [version 1.2 r5]
  -- Fixed bug with Resource File search path.

2001-11-20 [version 1.2 r4]
  -- Fixed generation of unique output filenames. 
  -- Unique output filename built up with decimal document
     count value instead of hex value.
  -- Fixed Resource Position when directly referenced within the Page.
  -- Fixed Image Object position problem.

2001-11-13 [version 1.2 r3]
  -- Added WaterMark support for PDF and TIFF(windows only) output.
  -- Fixed bug with overriding MappingDef details for CodedFont entries.
  -- Extended to use Resource Name from BR SFI when it occurs both in BR and 
     corresponding resource's Begin SFI (e.g Begin Coded Font)

2001-10-24 [version 1.2 r2]
  -- Extended support for Outline Coded Fonts.
  -- Changed CR to CRLF in generated CSV/XML Document Index files.

2001-09-14 [version 1.2]
  -- Added AFP Font Metric support.
  -- Added Strict option.
  -- Added PageRotation option.
  -- Added PNG (Portable Network Graphics) Output Format support.
  -- Added support for Underline, Overstrike features for TIFF and PDF output formats.
  -- Extended Document Merge (DOC_MERGE) option for AFP Input also.
  -- Fixed bug on Bookmark creation for Multiple input files.
  -- Fixed minor bugs in Ascii Output.
  -- User's guide updated.
  -- Generates Protocol file with process information for DocIndex option.
  -- Added Document From / To generating option.
  -- Added Outline Font support.
  -- Added seperate resource path list for Overlays, Page Segments, FormDefs and AFPFonts.
  -- External Font resource parsing supported.
  -- PDF Output: Added encoding support( ANSI, SYMBOL, Built-In ).
  -- Command line option: Support for specifying ini file name added.
  -- Support for writing a page immediately after parsing that page added.

2001-08-31 [version 1.1.5 r6]
  -- License agreement modified

2001-01-19 [version 1.1.5 r5]
  -- Parse one page and write it straight is now default processing.
  -- Write later (-wl) option added: Parse all pages first, then write them.

2001-05-10 [version 1.1.5 r4]
  -- PDF Output: fixed bug with positioning Complex Raster Images (Cells Position)
  -- Index Output: fixed bug CSV Format ( Improper Attribute Values )
  -- Ini File Parameters: removed case sensitive check
  -- Ini File Parameters: made all Flag Parameters input as on/off instead of yes/no
  -- User's guide updated

2001-05-02 [version 1.1.5 r3]
  -- PDF Output: fixed bug with BT and ET Fields
  -- Applying First Medium Map Occuring in Selected FormMap as Default 

2001-02-12 [version 1.1.5 r2]
  -- PDF Output: fixed bug when embbeding fonts.

2000-12-15 [version 1.1.5]
  -- First Solaris 2.6/2.7 Version.
  -- AFP Indexes added.
  -- TIFF Output for Linux and Solaris 2.6/2.7 added.
  -- TIFF Format as Input added.
  -- TIFF DOC_MERGE option added.
  -- ASCII Output added.
  -- JPEG Output added.
  -- Stdin/Stdout support added.
  -- PAGE option added.
  -- Resource File as Input added.
  -- Statistic File supported.
  -- IOCA Set Bilevel Image Color condition supported.
  -- PTOCA Text suppression handling added.
  -- CRLF supported.

2000-07-20 [version 1.1.4]
  -- First Linux Version.
  -- FGID support (AS/400) added.
  -- PDF colored Texts and images supported.
  -- FORMDEF support extended.
  -- Resource access optimized.
  -- Fixed IOCA decompressing problem.
  -- Logging Level extended.
  -- Color TIFF support for JPEG and UNCOMPRESSED fixed.

2000-04-26 [version 1.1.3]
  -- IOCA support added.
  -- FORMDEF (-fd) option added.
  -- Preview (-pv) option added.
  -- Error/Statistic file added.
  -- FORMDEF parsing extended: Page Offset supported.
  -- Support for Italic fonts added.
  -- Fixed problem when embedding Type 1 Bold fonts.
  -- Object List optimized.
  -- Medium Map (copygroup) Invocation within Triplet supported.
  -- Logging Font information extended.
  -- Resource extension definition within INI file added.
  -- Fixed bug in celled image.

2000-03-02 [version 1.1.2]
  -- Line Printer Data as input supported.
  -- Problem with embedding fonts fixed.
  -- Negative line width and height support added.
  -- Unique name generation (-u) option added.
  -- TIFF generation problems fixed.

2000-02-23 [version 1.1.1]
  -- Font Path (-fp:) option for embedding fonts added.
  -- FORMDEF support added.
  -- PDF Creator added.
  -- Quiet mode (-q) option added.
  -- Lines and Overlays positioning problems fixed.

2000-02-04 [version 1.1]
  -- TIFF output supported.
  -- In-line resources supported.
  -- Wildcard support for input files added.
  -- One/Multiple output files suppored.
  -- Performance optimized.
  -- INI file support added.

1999-12-08 [version 1.0.8]
  -- PDF Document size optimized.
  -- Performance optimized.
  -- Text rotation fully supported.

1999-10-25 [version 1.0.7]
  -- New command line option -op for output path added.
  -- Problem with mapping text having 270 degree rotation fixed.
  -- Default font properly processed.
  -- New linked list used.

1999-10-20 [version 1.0.6]
  -- Processing of multiple documents within a single file added.
  -- Mapping.def updated.

1999-09-24 [version 1.0.5]
  -- Use of Mapping.def for font mapping added.
  -- Minor bugs corrected.

1999-09-17 [version 1.0.4]
  -- First beta release.
